﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Reflection;
using Produmex.Foundation.Diagnostics;
using Produmex.Foundation.Workflows;
using Produmex.Foundation.Workflows.Parameters;
using System.Globalization;
using Produmex.Sbo.Logex.Data.BusinessObjects;
using Produmex.Foundation.SlimScreen;
using Produmex.Foundation.Wwf.Sbo.LocalServices;
using System.Data;
using Produmex.Sbo.Logex.Data.DataObjects;
using Produmex.Foundation.Data.Sbo;
using Produmex.Sbo.Logex.Data.Providers;
using Produmex.Foundation.Data.Sbo.Providers;
using Produmex.Sbo.Logex.Data.BusinessObjects.Definitions;
using Produmex.Foundation.Data.Sbo.BusinessObjects;
using System.Collections.ObjectModel;
using Produmex.Foundation.SlimScreen.Interfaces.Definitions.KnownDataSets;
using Produmex.Foundation.Data.SqlClient;
using Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.Tables;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.Tables;
using Produmex.Sbo.Logex.Dotani;
using Produmex.Sbo.Logex.Dotani.Providers;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions;
using Produmex.Foundation.Data.Sbo.Utilities;
using Produmex.Foundation.Data.DbClient;
using Produmex.Foundation.SlimScreen.Interfaces.Definitions;
using Produmex.Foundation.SlimScreen.Interfaces.Definitions.DataObjects;
using Produmex.Foundation.Data;
using Produmex.Foundation;
using Produmex.Foundation.Utilities;
using Produmex.Foundation.Data.Sbo.DataObjects;
using Produmex.Sbo.Logex.Data.Extensions.Interfacing.Definitions;

// PmxWorkflowExecutionTypes.SUB_FLOW
namespace WorkflowScript_RepackWeightScriptDotani
{
	public class WorkflowScript_RepackWeightScriptDotani : WorkflowInstanceScriptBase
	{
		private static readonly ILog s_log = LogProvider.GetLogger(MethodInfo.GetCurrentMethod().DeclaringType);

		// Input parameters
		public ReadOnlyBinder<CultureInfo> DefaultCultureInfo;
		public ReadOnlyBinder<PmxOseCompany> PmxOseCompany;
		public ReadOnlyBinder<bool> UseItemQuantityCombinedScreen;

		// Output parameters
		// <none>

		ISboProviderService m_sboProviderService;

		/// <summary>
        /// Initializes a new instance of the <see cref="WorkflowScript"/> class.
        /// </summary>
        /// <param name="parent">The parent.</param>
        /// <param name="factory">The factory.</param>
		public WorkflowScript_RepackWeightScriptDotani(WorkflowInstanceBase parent, WorkflowInstanceFactory factory)
            : base(parent, factory)
		{
        }


		#region WorkflowInstanceScriptBase Members
		/// <summary>
		/// Executes this instance.
		/// </summary>
		protected override void Execute()
		{
			// Parameters in scope
			Session session = GetScopeParameter("Session") as Session;
			m_sboProviderService = GetScopeParameter("<WwfService>ISboService") as ISboProviderService;

			string deviceID = session.DeviceInstanceId;
			string query = null;

			Produmex.Foundation.Messages.Message msg = null;

			string productionLineCode = null;
			string productionLineCodeForDevice = null;
			PmxOseWarehouseInfo whsInfo = null;
			DataSet dsProductionLines = null;
			string inputLocationCode = null;
			string restLocationCode = null;
			string outputLocationCode = null;
			string initialErrorKey = null;
			DataSet dsStartedProductionOrders = null;

			List<int> productionOrderDocEntries = new List<int>();
			bool isStarted = false;

			string itemCode = null;
			double tolerance = 0.0;

			DataSet dsStock = null;
			DataSet dsBatchAttributes = null;
			DataSet ds = null;

			bool lineUpLocationFromProductionTask = false;
			bool printItemLabel = false;
			string linedUpLocation = null;

			GeneratedBatchAndBestBeforeDateInfo batchAndBestBeforeDateInfo = null;
			string batchNumber = null;
			string batchNumber2 = null;
			DateTime? bestBeforeDate = null;
			int? itriKey = null;

			PmxItemInfo itemInfo = null;
			//string[] allowedButtonKeysForProductionInfoScreen = null;
			//string buttonKeySelectProductionTaskScreen = null;
			DataSet dsItemsToReceive = null;
			string itemCodeToReceive = null;

			int numberOfReports = 0;
			int? existingLuid = null;
			string logisticCarrierCode = null;

			Collection<ItemTransactionalPackagingTypeInfo> currentListOfTransactionalPackagingTypeInfos = null;
			PmxItemInfo itemInfoToReceive = null;
			int productionOrderLineToReceive = 0;
			double quantityToReceive = 0;
			double? quantityUom2ToReceive = null;
			Collection<string> listOfSerialNumbers = null;
			bool askReprint = false;
			//bool needsToBeLinedUp = false;

			List<string> allowedButtonsForStopProductionTask = new List<string>();
			PmxUserGroupAuthorizationCodes authorizationStopButton = PmxUserGroupAuthorizationCodes.Enabled;//Default enabled
			PmxUserGroupAuthorizationCodes authorizationOnHoldButton = PmxUserGroupAuthorizationCodes.Enabled;//Default enabled
			string userCode = null;
			Collection<ConsumeItemInfo> listConsumeItemsToSend = new Collection<ConsumeItemInfo>();
			DataSet dsProductOnLine = null;
			Collection<KeyValuePair<string, ItemSetpointInfo>> listOfItemCodesAndQuantity = null;
			Collection<ItemTransactionalBatchAttributeInfo> currentListOfTransactionalBatchAttributeInfos = null;

			double baseQty = 0;
			double issuedQty = 0;
			double quantity = 0;
			double completedQty = 0;
			//Get default settings
			bool goBack = false;
			bool autoMoveAllItemsLinkedToBOM = false;
			bool allowToMoveFromRest = false;
			bool allowStartingProdOrderOnFlow = false;

			bool useItemQuantityCombinedScreen = UseItemQuantityCombinedScreen != null ? UseItemQuantityCombinedScreen.Get() : false;
			Collection<int> createdLUIDs = null;
			bool printOnGoBack = false;
			bool useWaste = false;

			int productionOrderDocEntry = -1;
			int productionOrderLineNum = 0; //always 0

			const string PmxProductionStatus = "PmxProductionStatus";

			m_sboProviderService.InvokeMethodWithDbConnection<object>(true, false, null, null,
			 delegate(PmxDbConnection conn, object[] parameters)
			 {
				 PmxProductionOrderProvider prdProv = new PmxProductionOrderProvider((SboConnection)conn);
				 Dictionary<string, PmxParameterValue> plcParams = prdProv.GetParametersProductionController();

				 useWaste = PmxParameterValueProvider.GetParameterValue<bool>(plcParams, PmxExtensionParameterCodes.PRODUCTION_CONTROLLER_USE_WASTE, false);
				 autoMoveAllItemsLinkedToBOM = PmxParameterValueProvider.GetParameterValue<bool>(plcParams, PmxExtensionParameterCodes.PRODUCTION_CONTROLLER_AUTO_MOVE_ITEMS_LINKED_TO_BOM, false);
				 allowToMoveFromRest = PmxParameterValueProvider.GetParameterValue<bool>(plcParams, PmxExtensionParameterCodes.PRODUCTION_CONTROLLER_MOVE_TO_PROD_LINE_FROM_REST, false);
				 allowStartingProdOrderOnFlow = PmxParameterValueProvider.GetParameterValue<bool>(plcParams, PmxExtensionParameterCodes.PRODUCTION_CONTROLLER_ALLOW_START_PRODUCTION_RECEIPT, false);

				 return null;
			 });

			whsInfo = m_sboProviderService.InvokeMethodWithDbConnection<PmxOseWarehouseInfo>(false, false, null, null, new DelegateWithPmxDbConnection<PmxOseWarehouseInfo>(ExecuteGetPmxWarehouseCode), deviceID);

		Step_SelectProductionLine:

			#region SELECT PRODUCTION LINE

			query = BuildQuery.GetProductionLines(whsInfo.PmxWarehouseCode, deviceID);
			dsProductionLines = m_sboProviderService.RunView(false, null, null, query);

			if (this.GetNumberOfRows(dsProductionLines) > 0 &&
				!string.IsNullOrEmpty(productionLineCodeForDevice) &&
				!goBack)
			{
				productionLineCode = productionLineCodeForDevice;
				goto Step_GetProductionLineInfo;
			}

			if (this.GetNumberOfRows(dsProductionLines) == 1 && !goBack)
			{
				//auto select location
				productionLineCode = Convert.ToString(dsProductionLines.Tables[0].Rows[0][LocationDataSet.Columns.CODE.Name]);
				goto Step_GetProductionLineInfo;
			}

			goBack = false;

			session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.ISelectLocationScreen),
			   DefaultCultureInfo.Get(), BuildParamCollection(
			   "InitialErrorKey", initialErrorKey,
			   "TitleKey", "MSG_TITLE_SELECT_PRODUCTION_LINE",
			   "LocationDS", dsProductionLines
			   ));
			msg = WaitForMessage();
			initialErrorKey = null;
			if (msg.Name.EndsWith(".LocationSelected"))
			{
				productionLineCode = ExtractParameter<string>(msg.Parameters, "locationCode");
				goto Step_GetProductionLineInfo;
			}

			if (msg.Name.EndsWith(".RefreshRequested"))
			{
				goto Step_SelectProductionLine;
			}

			//back requested
			return;

			#endregion

		Step_GetProductionLineInfo:

			#region GET PRODUCTION LINE INFO


			if (this.GetNumberOfRows(dsProductionLines) > 0)
			{
				DataRow[] rows = dsProductionLines.Tables[0].Select(LocationDataSet.Columns.CODE.Name + " = '" + productionLineCode + "'");
				if (rows.Length > 0)
				{
					DataRow row = rows[0];
					inputLocationCode = row[PmxOseProductionLineTable.Columns.InputLocationCode.NAME] as string;
					outputLocationCode = row[PmxOseProductionLineTable.Columns.OutputLocationCode.NAME] as string;
					restLocationCode = row[PmxOseProductionLineTable.Columns.RestLocationCode.NAME] as string;
					string warehouseCode = row[LocationDataSet.Columns.WAREHOUSECODE.Name] as string;
					if (warehouseCode != whsInfo.PmxWarehouseCode)
					{
						whsInfo = m_sboProviderService.InvokeMethodWithDbConnection<PmxOseWarehouseInfo>(false, false, null, null, new DelegateWithPmxDbConnection<PmxOseWarehouseInfo>(ExecuteGetPmxWarehouseCode), warehouseCode);
					}

				}
				else
				{
					//production line not found!
					//This should not happen
					goBack = true;
					goto Step_SelectProductionLine;
				}
			}
			else
			{
				//production line not found!
				//This should not happen
				goBack = true;
				goto Step_SelectProductionLine;
			}

			goto Step_GetStartedProductionOrders;

			#endregion

		Step_GetStartedProductionOrders:

			#region GET STARTED PRODUCTION ORDER

			productionOrderDocEntries.Clear();
			query = BuildQuery.GetStartedProductionOrders(productionLineCode, allowStartingProdOrderOnFlow);
			dsStartedProductionOrders = m_sboProviderService.RunView(false, null, null, query);

			if (this.GetNumberOfRows(dsStartedProductionOrders) == 0)
			{
				goto Step_SelectProductionLine;
			}

			for (int i = 0; i < dsStartedProductionOrders.Tables[0].Rows.Count; i++)
			{
				int prodDocEntry = Convert.ToInt32(dsStartedProductionOrders.Tables[0].Rows[i][ProductionOrderDataSet.Columns.PRODUCTION_ORDER_DOC_ENTRY.Name]);
				
				if (!productionOrderDocEntries.Contains(prodDocEntry))
				{
					productionOrderDocEntries.Add(prodDocEntry);
				}
			}

			goto Step_EnterItemQuantityCombined;

			#endregion

		Step_EnterItemQuantityCombined:

			#region ENTER ITEM/QUANTITY COMBINED
			printOnGoBack = false;

			query = BuildQuery.GetItemsToReceive(productionOrderDocEntries, lineUpLocationFromProductionTask, true, m_sboProviderService.GetDbTool());
			dsItemsToReceive = m_sboProviderService.RunView(false, null, null, query);

			PmxScaleDefinitionProvider.ScaleConfig scaleConfig = GetScaleConfig(session);

			//ask for quantity
			session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.Production.IEnterItemQuantityCombinedScreen),
				DefaultCultureInfo.Get(), BuildParamCollection(
					"InitialErrorKey", initialErrorKey,
					"TitleKey", "MSG_TITLE_ENTER_QUANTITY_DISASSEMBLED",
					"InitialQuantity", 0,
					"NumberOfDigitsAfterDecimal", 6,
					"MaximumQuantity", null,
					"UOM", "",
					"ProductionOrderLineDS", dsItemsToReceive,
					"ButtonKey", existingLuid.HasValue ? "MSG_BUTTON_LOGISTIC_CARRIER_IS_FULL" : null,
					"ScaleProviderType", scaleConfig.ProviderType,
					"ScaleDecimals", scaleConfig.Decimals,
					"ScaleMaxWeight", scaleConfig.MaxWeight,
					"ScaleSettings", scaleConfig.Settings
				   ));
			msg = WaitForMessage();

			//clear data
			initialErrorKey = null;

			if (msg.Name.EndsWith(".ItemQuantityEntered"))
			{
				productionOrderDocEntry = ExtractParameter<int>(msg.Parameters, "prodOrderDocEntry");
				productionOrderLineNum = ExtractParameter<int>(msg.Parameters, "productionOrderLineNum"); //always 0
				quantityToReceive = ExtractParameter<double>(msg.Parameters, "quantity");
				itemCodeToReceive = ExtractParameter<string>(msg.Parameters, "itemCode");

				itemInfoToReceive = m_sboProviderService.InvokeMethodWithDbConnection<PmxItemInfo>(false, false, null, null, new DelegateWithPmxDbConnection<PmxItemInfo>(ExecuteGetItemInfo), itemCodeToReceive);

				DataRow[] rows2 = dsStartedProductionOrders.Tables[0].Select(ProductionOrderLineDataSet.Columns.PRODUCTION_ORDER_DOC_ENTRY.Name + " = " + productionOrderDocEntry.ToString());

				if (rows2.Length > 0)
				{
					isStarted = rows2[0][PmxProductionStatus] as string == "S" ? true : false;
					itemCode = Convert.ToString(rows2[0]["ItemCode"]);
				}
				else
				{
					//rows2, rows3.Length == 1 
					//initialErrorKey = "row2 empty";
					goto Step_SelectProductionLine;
				}

				DataRow[] rows3 = dsItemsToReceive.Tables[0].Select(ProductionOrderLineDataSet.Columns.PRODUCTION_ORDER_DOC_ENTRY.Name + " = " + productionOrderDocEntry.ToString());

				if (rows3.Length > 0)
				{
					tolerance = Convert.ToDouble(rows3[0]["U_PMX_QTYTOLPCT"]);
					baseQty = Convert.ToDouble(rows3[0]["BaseQty"]);
					issuedQty = Convert.ToDouble(rows3[0]["IssuedQty"]);
					quantity = Convert.ToDouble(rows3[0]["Quantity"]);
					completedQty = Convert.ToDouble(rows3[0]["CmpltQty"]);
				}
				else
				{
					//initialErrorKey = "row3 empty";
					goto Step_SelectProductionLine;
				}

				if (!isStarted)
				{
					goto Step_StartProductionOrder;
				}

				goto Step_SelectStock;
			}
			if (msg.Name.EndsWith(".BackRequested"))
			{
				goBack = true;
				goto Step_SelectProductionLine;
			}

			#endregion

		Step_StartProductionOrder: 

			#region START PRODUCTION ORDER

				try
				{
					m_sboProviderService.InvokeMethodWithDbConnection<object>(true, false, null, null,
					 delegate(PmxDbConnection conn, object[] parameters)
					 {
						 PmxProductionOrderProvider prdProv = new PmxProductionOrderProvider((SboConnection)conn);
						 prdProv.StartProductionOrder(productionOrderDocEntry);

						 return null;
					 });
				}

				catch (Exception ex)
				{
					s_log.Error("", ex);
					if (ex is ProdumexException)
					{
						// Inform the user with the error
						session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
							DefaultCultureInfo.Get(), BuildParamCollection(
								"PmxError", ((ProdumexException)ex).Error,
								"ShowButton", true));
						WaitForMessage();

						if (((ProdumexException)ex).Error.ErrorCode == Produmex.Sbo.Logex.Data.ProdumexErrorCodes.ProductionOrderCannotBeStartedBeforeWeighingComponents)
						{
							goto Step_SelectProductionLine;
						}
					}
					else
					{
						// Inform the user with the error
						session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
							DefaultCultureInfo.Get(), BuildParamCollection(
								"MessageKey", ExceptionHelper.Format(ExceptionHelper.Content.InnerExceptions, ex, DefaultCultureInfo.Get()),
								"NoTranslationOfMessageKey", true,
								"IsError", true,
								"ShowButton", true));
						WaitForMessage();
					}

					//ask user if he wants to try again after error
					session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
						DefaultCultureInfo.Get(), BuildParamCollection(
							"TitleKey", "MSG_TITLE_ERROR_TRY_AGAIN",
							"MessageKey", "MSG_QUESTION_ERROR_TRY_AGAIN"));
					msg = WaitForMessage();

					if (msg.Name.EndsWith(".Yes"))
					{
						goto Step_StartProductionOrder;
					}

					goBack = true;
					goto Step_SelectProductionLine;

			}

			#endregion

		Step_SelectStock:

			#region SELECT STOCK
			
			batchAndBestBeforeDateInfo = new GeneratedBatchAndBestBeforeDateInfo();

			if (autoMoveAllItemsLinkedToBOM)
			{

				#region MOVE ALL ITEMS LINKED TO BOM

				//get all itemcodes for production order
				Collection<string> listOfItemCodesToMove = new Collection<string>();
				listOfItemCodesToMove.Add(itemCode);


				//move all data linked to production order
				m_sboProviderService.InvokeMethodWithDbConnection<object>(false, false, null, null,
					 delegate(PmxDbConnection conn, object[] parameters)
					 {
						 PmxOseProductionLineProvider prov = new PmxOseProductionLineProvider(conn);
						 prov.MoveItemsFromInputToProductionLine(productionLineCode, listOfItemCodesToMove, allowToMoveFromRest, productionOrderDocEntry);
						 return null;
					 });


				#endregion

			}
			
			//query = BuildQuery.GetStock(productionLineCode, itemCode, m_sboProviderService.GetDbTool());
			//dsStock = m_sboProviderService.RunView(false, null, null, query);
			query = BuildQuery.GetProductsOnLineDisassembly(productionOrderDocEntry, productionLineCode, itemCode, PmxOseCompany.Get().LogisticCarriersStoredOnOneStorageLocation ? whsInfo.StorageLocationCodeLogisticCarriers : null, m_sboProviderService.GetDbTool());
			dsStock = m_sboProviderService.RunView(false, null, null, query);

			currentListOfTransactionalBatchAttributeInfos = new Collection<ItemTransactionalBatchAttributeInfo>();
			//currentListOfTransactionalBatchAttributeInfos.Clear();

			bool allowedBooking = true;

			#region Check tolerance
			double mainQty = 0;

			for (int i = 0; i < dsStock.Tables[0].Rows.Count; i++)
			{
				mainQty += Convert.ToDouble(dsStock.Tables[0].Rows[i]["Quantity"]);
			}

			double availableQuantity = mainQty * baseQty;
			if (availableQuantity < quantityToReceive)
			{
				// not enough stock - check for tolerance
				double productQuantityBookedSoFar = completedQty; // prod order completed qty //owor.Cmpltqty
				double totalProductQuantityBooked = productQuantityBookedSoFar + mainQty;

				double componentQuantityBookedSoFar = issuedQty;
				double totalComponentQuantityBooked = componentQuantityBookedSoFar + quantityToReceive;

				double minimumTotalProductQuantityAllowed = (totalComponentQuantityBooked / baseQty) * (100 - tolerance) / 100;

				if (totalProductQuantityBooked < minimumTotalProductQuantityAllowed)
				{
					allowedBooking = false;
				}
			}
			#endregion
				
			if ( allowedBooking )
			{
				if (dsStock.Tables[0].Rows.Count == 0)
				{
					query = BuildQuery.GetLastBatch(productionOrderDocEntry, m_sboProviderService.GetDbTool());
					dsStock = m_sboProviderService.RunView(false, null, null, query);

				}

				batchAndBestBeforeDateInfo.BatchNumber = Convert.ToString(dsStock.Tables[0].Rows[0][PmxItemTransactionalInfoTable.Columns.BatchNumber1.NAME]);
				batchNumber = Convert.ToString(dsStock.Tables[0].Rows[0][PmxItemTransactionalInfoTable.Columns.BatchNumber1.NAME]);
				batchAndBestBeforeDateInfo.BatchNumber2 = Convert.ToString(dsStock.Tables[0].Rows[0][DefaultPmxDocumentLine.Columns.BatchNumber2.NAME]);
				batchAndBestBeforeDateInfo.BestBeforeDate = (dsStock.Tables[0].Rows[0][PmxItemTransactionalInfoTable.Columns.BestBeforeDate.NAME]) == System.DBNull.Value ? null : (DateTime?)(dsStock.Tables[0].Rows[0][PmxItemTransactionalInfoTable.Columns.BestBeforeDate.NAME]);
				bestBeforeDate = batchAndBestBeforeDateInfo.BestBeforeDate;
				itriKey = (int?)(dsStock.Tables[0].Rows[0][PmxInventoryDetailTable.Columns.ItemTransactionalInfoKey.NAME]);
				//itriKey = (int?)(dsStock.Tables[0].Rows[0]["InternalKey"]);

				query = BuildQuery.GetBatchAttributes(itemCode, itriKey, m_sboProviderService.GetDbTool());
				dsBatchAttributes = m_sboProviderService.RunView(false, null, null, query);

				for (int i = 0; i < dsBatchAttributes.Tables[0].Rows.Count; i++)
				{
					ItemTransactionalBatchAttributeInfo binfo = new ItemTransactionalBatchAttributeInfo();
					binfo.AttributeValue = Convert.ToString(dsBatchAttributes.Tables[0].Rows[i][PmxItemTransactionalBatchAttributeTable.Columns.AttributeValue.NAME]);
					binfo.BatchAttributeCode = Convert.ToString(dsBatchAttributes.Tables[0].Rows[i][PmxItemTransactionalBatchAttributeTable.Columns.BatchAttributeCode.NAME]);
					binfo.InternalKey = (int?)dsBatchAttributes.Tables[0].Rows[i][PmxItemTransactionalBatchAttributeTable.Columns.InternalKey.NAME]; //== DBNull.Value ? null : Convert.ToInt32(dsBatchAttributes.Tables[0].Rows[i][PmxItemTransactionalBatchAttributeTable.Columns.InternalKey.NAME]);
					binfo.IsLinkedToBatch = false;
					binfo.ItemCode = Convert.ToString(dsBatchAttributes.Tables[0].Rows[i][PmxItemTransactionalInfoTable.Columns.ItemCode.NAME]);
					binfo.ItriKey = (int?)dsBatchAttributes.Tables[0].Rows[i][PmxItemTransactionalBatchAttributeTable.Columns.ItemTransactionalInfoKey.NAME]; //== DBNull.Value ? null : Convert.ToInt32(dsBatchAttributes.Tables[0].Rows[i][PmxItemTransactionalBatchAttributeTable.Columns.ItemTransactionalInfoKey.NAME]);
					binfo.ValueConvertor = Convert.ToString(dsBatchAttributes.Tables[0].Rows[i][PmxItemTransactionalBatchAttributeTable.Columns.ValueConvertor.NAME]);

					currentListOfTransactionalBatchAttributeInfos.Add(binfo);
				}
				//break; // only book for 1st found batch

				
				if (allowedBooking == false)
				{
					initialErrorKey = "MSG_ERROR_NOT_ENOUGH_STOCK_TO_DISASSEMBLE";
					goto Step_SelectProductionLine;
				}

				goto Step_ProduceStock;
			}
			if (allowedBooking == false)
			{
				initialErrorKey = "MSG_ERROR_NOT_ENOUGH_STOCK_TO_DISASSEMBLE";
				goto Step_SelectProductionLine;
			}

			#endregion

		Step_ProduceStock:

			#region PRODUCE STOCK

		Step_Produce_Again:

			//produce stock
			createdLUIDs = new Collection<int>();
			try
			{
				double splitQty = quantityToReceive;
				double? splitQtyUom2 = quantityUom2ToReceive;

				m_sboProviderService.InvokeMethodWithDbConnection<object>(true, false, null, null,
					delegate(PmxDbConnection conn, object[] parameters)
					{
						PmxDotaniProductionOrderProvider prdProv = new PmxDotaniProductionOrderProvider((SboConnection)conn);

						Collection<string> fullListOfSerialNumbers = listOfSerialNumbers;

						Collection<ProductionReceiptLogisticUnitInfo> listOfLogUnits = new Collection<ProductionReceiptLogisticUnitInfo>();

						query = BuildQuery.GetStock(productionLineCode, itemCode, m_sboProviderService.GetDbTool());
						dsStock = m_sboProviderService.RunView(false, null, null, query);

						ProductionReceiptLogisticUnitInfo logUnit = new ProductionReceiptLogisticUnitInfo();
						logUnit.LUID = null;
						logUnit.SetLUID = true;
						logUnit.LogisticCarrierCode = itemInfoToReceive.DefaultLogisticCarrierProduction ?? ""; //logisticCarrierCode;

						listOfLogUnits.Add(logUnit);

						Collection<string> tempListOfSerialNumbers = new Collection<string>();

						ProductionReceiptItemInfo logUnitItem = new ProductionReceiptItemInfo();
						logUnitItem.BatchInfo = batchAndBestBeforeDateInfo;
						logUnitItem.BatchInfo.BatchNumber = batchNumber;
						logUnitItem.BatchInfo.BatchNumber2 = batchNumber2;
						logUnitItem.BatchInfo.BestBeforeDate = bestBeforeDate;
						logUnitItem.ItemCode = itemCodeToReceive;
						logUnitItem.ListOfPackagingTypes = currentListOfTransactionalPackagingTypeInfos;
						logUnitItem.ListOfSerialNumbers = tempListOfSerialNumbers;

						logUnitItem.Quantity = quantityToReceive;
						logUnitItem.QuantityUom2 = quantityUom2ToReceive;
						logUnitItem.ProductionOrderLineNum = productionOrderLineToReceive;

						logUnitItem.ListOfBatchAttributes = currentListOfTransactionalBatchAttributeInfos;
						logUnitItem.LinedUpLocation = linedUpLocation;
						logUnit.ItemsOnLogisticUnit.Add(logUnitItem);

						//produce         
						createdLUIDs = prdProv.ReceiveDisassemblyDotani(productionOrderDocEntry, listOfLogUnits, outputLocationCode, whsInfo.PmxWarehouseCode, 1);//productionInformation.CurrentProdBatch);

						string minQuantityColumnName = "MinQty";
						string maxQuantityColumnName = "MaxQty";

						query = BuildQuery.GetMinMaxForHeaderConsumption(productionOrderDocEntry, minQuantityColumnName, maxQuantityColumnName, m_sboProviderService.GetDbTool());
						using (ISboRecordset rs = SboRecordsetHelper.RunQuery(s_log, query, conn))
						{
							ds = SboRecordsetHelper.ConvertRecordsetToDataSet(s_log, rs);
						}

						//itemInfo = m_sboProviderService.InvokeMethodWithDbConnection<PmxItemInfo>(false, false, null, null, new DelegateWithPmxDbConnection<PmxItemInfo>(ExecuteGetItemInfo), itemCode);
						itemInfo = ExecuteGetItemInfo(conn, new object[] { itemCode });

						double minimumQtyHeader = 0;
						double maximumQtyHeader = double.MaxValue;
						double qtyToUseHeader = double.MaxValue;

						if (this.GetNumberOfRows(ds) > 0)
						{
							//We found some rows, to now get minimum and maximum
							foreach (DataRow row in ds.Tables[0].Rows)
							{
								minimumQtyHeader = Math.Max(minimumQtyHeader, Convert.ToDouble(row[minQuantityColumnName]));
								maximumQtyHeader = Math.Min(maximumQtyHeader, Convert.ToDouble(row[maxQuantityColumnName]));

								qtyToUseHeader = Math.Min(qtyToUseHeader, Convert.ToDouble(row[PmxProductionReceiptLineTable.Columns.Quantity.NAME]));
							}

							//Round the quantity
							minimumQtyHeader = Math.Round(minimumQtyHeader, itemInfo.UomDecimals);
							maximumQtyHeader = Math.Round(maximumQtyHeader, itemInfo.UomDecimals);
							qtyToUseHeader = Produmex.Foundation.Utilities.FormattingHelper.CeilingForDecimals(qtyToUseHeader, itemInfo.UomDecimals);

							if (minimumQtyHeader > maximumQtyHeader)
							{
								Collection<string> listOfItemCodes = new Collection<string>();
								//Loop again to get items that are not received
								foreach (DataRow row in ds.Tables[0].Rows)
								{
									double tempQty = Convert.ToDouble(row[maxQuantityColumnName]);

									if (tempQty < minimumQtyHeader)
									{
										listOfItemCodes.Add(row[PmxProductionOrderLineTable.Columns.ItemCode.NAME] as string);
									}
								}

								//Some items were not fully received.
								// Inform the user with the error
								session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
									DefaultCultureInfo.Get(), BuildParamCollection(
										"MessageKey", "MSG_ERROR_NOT_ALL_ITEMS_RECEIVED_FOR_DISASSEMBLY",
										"NoTranslationOfMessageKey", false,
										"IsError", true,
										"MessageAddendum", StringHelper.ConvertListToString(listOfItemCodes),
										"ShowButton", true));
								WaitForMessage();
							}
						}

						query = BuildQuery.GetProductsOnLineDisassembly(productionOrderDocEntry, productionLineCode, itemCode, PmxOseCompany.Get().LogisticCarriersStoredOnOneStorageLocation ? whsInfo.StorageLocationCodeLogisticCarriers : null, m_sboProviderService.GetDbTool());
						using (ISboRecordset rs = SboRecordsetHelper.RunQuery(s_log, query, conn))
						{
							dsProductOnLine = SboRecordsetHelper.ConvertRecordsetToDataSet(s_log, rs);
						}

						listConsumeItemsToSend = new Collection<ConsumeItemInfo>();

						listOfItemCodesAndQuantity = new Collection<KeyValuePair<string, ItemSetpointInfo>>();
						if (this.GetNumberOfRows(dsProductOnLine) > 0)
						{
							string currentItemCode = null;
							double qtyUsed = 0;
							double? qtyUom2Used = 0;

							Collection<string> listOfPreparedItemCodes = new Collection<string>();

							foreach (DataRow row in dsProductOnLine.Tables[0].Rows)
							{
								double quantityOnLine = Convertor.ConvertToDouble(row[ConsumeItemsForProductionDataSet.Columns.QUANTITY.Name]);
								double quantityUom2OnLine = Convertor.ConvertToDouble(row[ConsumeItemsForProductionDataSet.Columns.QUANTITY_UOM2.Name]);

								double baseQuantity = Convertor.ConvertToDouble(row[ConsumeItemsForProductionDataSet.Columns.BASEQUANTITY.Name]);
								double qtyTolPercentage = Convertor.ConvertToDouble(row[ConsumeItemsForProductionDataSet.Columns.QTYTOLPERCENTAGE.Name]);

								double qtySetpoint = qtyToUseHeader;
								double qtyToUse = double.NaN;
								double? qtyUom2ToUse = null;

								if (currentItemCode != row[ConsumeItemsForProductionDataSet.Columns.ITEMCODE.Name] as string)
								{
									qtyUsed = 0;
									qtyUom2Used = 0;
									currentItemCode = row[ConsumeItemsForProductionDataSet.Columns.ITEMCODE.Name] as string;
									//add the itemcode to the list because we will use it later to loop tru the IEnterConsumeItemsScreens

									double qtyLowerLimit = Math.Round(minimumQtyHeader, itemInfo.UomDecimals);
									double qtyUpperLimit = Math.Round(maximumQtyHeader, itemInfo.UomDecimals);
									listOfItemCodesAndQuantity.Add(new KeyValuePair<string, ItemSetpointInfo>(currentItemCode, new ItemSetpointInfo(qtyLowerLimit, qtySetpoint, qtyUpperLimit)));

								}

								//set the used quantity;
								if (double.IsNaN(qtyToUse))
								{
									qtyToUse = Math.Min(quantityOnLine, qtySetpoint - qtyUsed);
									qtyUsed += qtyToUse;
																		
									//itemInfo = m_sboProviderService.InvokeMethodWithDbConnection<PmxItemInfo>(false, false, null, null, new DelegateWithPmxDbConnection<PmxItemInfo>(ExecuteGetItemInfo), currentItemCode);
									itemInfo = ExecuteGetItemInfo(conn, new object[] { currentItemCode });

									if (itemInfo.IsCatchWeightItem)
									{
										if (quantityOnLine == qtyToUse)
										{
											qtyUom2ToUse = quantityUom2OnLine;
										}
										else
										{
											//Use default ratio
											qtyUom2ToUse = PmxItemAllConnectionsProvider.CalculateWeightFromPieces(qtyToUse, itemInfo);
										}
										qtyUom2Used += qtyUom2ToUse;
									}
								}

								row[ConsumeItemsForProductionDataSet.Columns.QUANTITYUSED.Name] = qtyToUse;
								if (itemInfo.IsCatchWeightItem)
								{
									row[ConsumeItemsForProductionDataSet.Columns.QUANTITYUSED_UOM2.Name] = qtyUom2ToUse;
								}

								//set the rest
								row[ConsumeItemsForProductionDataSet.Columns.QUANTITYREST.Name] = quantityOnLine - qtyToUse;
								if (itemInfo.IsCatchWeightItem)
								{
									row[ConsumeItemsForProductionDataSet.Columns.QUANTITYREST_UOM2.Name] = quantityUom2OnLine - qtyUom2ToUse;
								}

							}


							listConsumeItemsToSend = new Collection<ConsumeItemInfo>();

							foreach (KeyValuePair<string, ItemSetpointInfo> itemCodeQuantity in listOfItemCodesAndQuantity)
							{
								string currenItemCodeForConsume = itemCodeQuantity.Key;
								ItemSetpointInfo totalToConsumeForItem = itemCodeQuantity.Value;

								//copy structure
								DataSet dsConsumeItemsByItemCode = dsProductOnLine.Clone();

								DataRow[] rows = dsProductOnLine.Tables[0].Select(ConsumeItemsForProductionDataSet.Columns.ITEMCODE.Name + " = '" + currenItemCodeForConsume + "'");

								foreach (DataRow row in rows)
								{
									//copy the items into the new ds
									dsConsumeItemsByItemCode.Tables[0].Rows.Add(row.ItemArray);
								}

								PmxItemInfo itemInfoToConsume = ExecuteGetItemInfo(conn, new object [] {currenItemCodeForConsume});
								//PmxItemInfo itemInfoToConsume = m_sboProviderService.InvokeMethodWithDbConnection<PmxItemInfo>(false, false, null, null, new DelegateWithPmxDbConnection<PmxItemInfo>(ExecuteGetItemInfo), currenItemCodeForConsume);

								DataSet dsConsumedItems = null;

								dsConsumedItems = dsConsumeItemsByItemCode;


								foreach (DataRow row in dsConsumedItems.Tables[0].Rows)
								{
									ConsumeItemInfo consume = new ConsumeItemInfo();

									consume.BatchNumber1 = row[ConsumeItemsForProductionDataSet.Columns.BATCHNUMBER.Name] as string;
									consume.BatchNumber2 = row[ConsumeItemsForProductionDataSet.Columns.BATCHNUMBER2.Name] as string;
									if (row[ConsumeItemsForProductionDataSet.Columns.BESTBEFOREDATE.Name] is DateTime)
									{
										consume.BestBeforeDate = Convert.ToDateTime(row[ConsumeItemsForProductionDataSet.Columns.BESTBEFOREDATE.Name]);
									}
									consume.ItemCode = row[ConsumeItemsForProductionDataSet.Columns.ITEMCODE.Name] as string;
									consume.ItemDescription = row[ConsumeItemsForProductionDataSet.Columns.ITEMDESCRIPTION.Name] as string;
									consume.LocationCode = row[ConsumeItemsForProductionDataSet.Columns.LOCATIONCODE.Name] as string;
									consume.LogisticUnitIdentKey = Convertor.ConvertToInt32Nullable(row[ConsumeItemsForProductionDataSet.Columns.LUID.Name]);
									consume.QualityStatusCode = row[ConsumeItemsForProductionDataSet.Columns.QUALITYSTATUSCODE.Name] as string;
									consume.QuantityUsed = Convert.ToDouble(row[ConsumeItemsForProductionDataSet.Columns.QUANTITYUSED.Name]);
									consume.QuantityWaste = Convert.ToDouble(row[ConsumeItemsForProductionDataSet.Columns.QUANTITYWASTE.Name]);
									consume.SSCC = row[ConsumeItemsForProductionDataSet.Columns.SSCC.Name] as string;

									if (itemInfo.IsCatchWeightItem)
									{
										consume.QuantityUom2Used = Convert.ToDouble(row[ConsumeItemsForProductionDataSet.Columns.QUANTITYUSED_UOM2.Name]);
										consume.QuantityUom2Waste = Convert.ToDouble(row[ConsumeItemsForProductionDataSet.Columns.QUANTITYWASTE_UOM2.Name]);
									}


									listConsumeItemsToSend.Add(consume);
								}
							}

						}

						if (listConsumeItemsToSend != null &&
							listConsumeItemsToSend.Count > 0)
						{
							//consume stock
							prdProv.Consume(productionOrderDocEntry, listConsumeItemsToSend);
						}

						return null;
					});
			}

			catch (Exception ex)
			{
				s_log.Error("", ex);
				if (ex is ProdumexException)
				{
					// Inform the user with the error
					session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
						DefaultCultureInfo.Get(), BuildParamCollection(
							"PmxError", ((ProdumexException)ex).Error,
							"ShowButton", true));
					WaitForMessage();
				}
				else
				{
					// Inform the user with the error
					session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
						DefaultCultureInfo.Get(), BuildParamCollection(
							"MessageKey", ExceptionHelper.Format(ex, this.DefaultCultureInfo),
							"NoTranslationOfMessageKey", true,
							"IsError", true,
							"ShowButton", true));
					WaitForMessage();
				}

				//ask user if he wants to try again after error
				session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
					DefaultCultureInfo.Get(), BuildParamCollection(
						"TitleKey", "MSG_TITLE_ERROR_TRY_AGAIN",
						"MessageKey", "MSG_QUESTION_ERROR_TRY_AGAIN"));
				msg = WaitForMessage();

				if (msg.Name.EndsWith(".Yes"))
				{
					goto Step_Produce_Again;
				}
				else
				{
					goto Step_SelectProductionLine;
				}
			}


			if (useItemQuantityCombinedScreen)
			{
				//Clear some data
				logisticCarrierCode = null;
			}

			goto Step_PrintProductionLabel;


			#endregion

		Step_PrintProductionLabel:

			#region PRINT PRODUCTION LABEL

			numberOfReports = 0;

			if (createdLUIDs.Count > 0)
			{
				try
				{
					//trigger event
					foreach (int createdLUID in createdLUIDs)
					{
						numberOfReports += m_sboProviderService.InvokeMethodWithDbConnection<int>(false, false, null, null,
						delegate(PmxDbConnection conn, object[] parameters2)
						{
							PmxPrintReportProvider printProv = new PmxPrintReportProvider(conn);
							return printProv.PrintReportsForEvent(PmxPrintReportEventType.ProductionLogisticUnitProduced,
								productionLineCode, deviceID, createdLUID, out askReprint);
						});
					}
				}
				catch (Produmex.Foundation.ProdumexException ex)
				{
					s_log.Error(ex.ToString());
					session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
						DefaultCultureInfo.Get(), BuildParamCollection(
							"InitialErrorKey", initialErrorKey,
							"MessageKey", KnownMessageKeys.MSG_ERROR_INTERNAL_ERROR,
							"MessageAddendum", ex.Message,
							"PmxError", ex.Error,
							"ShowButton", true));

					msg = WaitForMessage();
				}
				catch (Exception ex)
				{
					s_log.Error(ex.ToString());
					session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
						DefaultCultureInfo.Get(), BuildParamCollection(
							"InitialErrorKey", initialErrorKey,
							"MessageKey", KnownMessageKeys.MSG_ERROR_INTERNAL_ERROR,
							"MessageAddendum", ex.Message,
							"PmxError", Produmex.Sbo.Logex.Data.ProdumexErrors.UnexpectedError(s_log, ex),
							"ShowButton", true));

					msg = WaitForMessage();
				}


				if (numberOfReports > 0 && askReprint)
				{
					goto Step_DocumentsPrinted;
				}

				//if (!useItemQuantityCombinedScreen)
				//{
				//    //Only show message when we are not using combined item/quantity screen, because by using this, the item was already produced, and we came here when the user pressed 'Logistic unit full' button.
				//    //Produced items
				//    session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IShowMessageScreen),
				//       DefaultCultureInfo.Get(), BuildParamCollection(
				//           "InitialErrorKey", initialErrorKey,
				//           "MessageKey", productionInformation.IsDisassembly ? "MSG_ITEM_IS_DISASSEMBLED" : "MSG_ITEM_IS_PRODUCED",
				//           "ShowButton", true));

				//    this.WaitForMessage();
				//}


			}

			createdLUIDs.Clear();


			#endregion

		Step_DocumentsPrinted:

			#region DOCUMENTS PRINTED

			if (numberOfReports > 0 &&
				askReprint)
			{
				session.ShowScreen(typeof(Produmex.Foundation.SlimScreen.Interfaces.IDecisionScreen),
					DefaultCultureInfo.Get(), BuildParamCollection(
						"MessageKey", "MSG_QUESTION_REPRINT_LABEL",
						"TitleKey", "MSG_TITLE_REPRINT_LABEL"));

				msg = WaitForMessage();

				if (msg.Name.EndsWith(".Yes"))
				{
					goto Step_PrintProductionLabel;
				}

			}

			createdLUIDs.Clear();

			goto Step_EnterItemQuantityCombined;


			#endregion

		}
		#endregion


		#region HELPERS

		/// <summary>
		/// Executes the get PMX warehouse code.
		/// </summary>
		/// <param name="conn">The conn.</param>
		/// <param name="parameters">The parameters.</param>
		/// <returns></returns>
		private static PmxOseWarehouseInfo ExecuteGetPmxWarehouseCode(PmxDbConnection conn, object[] parameters)
		{
			PmxOseProvider oseProv = new PmxOseProvider(conn);
			return oseProv.GetPmxWarehouseInfo((string)parameters[0]);
		}

		/// <summary>
		/// Executes the get item info.
		/// </summary>
		/// <param name="conn">The conn.</param>
		/// <param name="parameters">The parameters.</param>
		/// <returns></returns>
		private static PmxItemInfo ExecuteGetItemInfo(PmxDbConnection conn, object[] parameters)
		{
			PmxItemAllConnectionsProvider prov = new PmxItemAllConnectionsProvider(conn);
			return prov.GetCachedItemInfo((string)parameters[0]);
		}

		/// <summary>
		/// Gets the number of rows.
		/// </summary>
		/// <param name="ds">The ds.</param>
		/// <returns></returns>
		private int GetNumberOfRows(DataSet ds)
		{
			if (ds != null && ds.Tables.Count > 0)
			{
				return ds.Tables[0].Rows.Count;
			}
			return 0;
		}

		private PmxScaleDefinitionProvider.ScaleConfig m_scaleConfig;

		private PmxScaleDefinitionProvider.ScaleConfig GetScaleConfig(Session session)
		{
			if (m_scaleConfig == null)
			{
				m_sboProviderService.InvokeMethodWithDbConnection<object>(false, false, null, null,
				delegate(PmxDbConnection dbConn, object[] parameters)
				{
					PmxScaleDefinitionProvider scaleDefProv = new PmxScaleDefinitionProvider();
					m_scaleConfig = scaleDefProv.GetThinClientScales(session.DeviceInstanceId, dbConn);

					if (m_scaleConfig == null)
					{
						m_scaleConfig = new PmxScaleDefinitionProvider.ScaleConfig()
						{
							ProviderType = "-"  // No scale defined
						};
					}

					return null;
				});
			}
			return m_scaleConfig;
		}

		#endregion

		#region QUERY

        /// <summary>
        /// Static class grouping our native queries
        /// </summary>
		private class BuildQuery
		{
			/// <summary>
			/// Gets all the production lines.
			/// </summary>
			/// <param name="warehouseCode">The warehouse code.</param>
			/// <returns>The sql statement to get all the production lines</returns>
			public static string GetProductionLines(string warehouseCode, string deviceID)
			{
				StringBuilder strBuilder = new StringBuilder();
				strBuilder.Append("SELECT ");

				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxOseStorageLocationGeneralTable.NAME, PmxOseStorageLocationGeneralTable.Columns.Code.NAME, LocationDataSet.Columns.CODE.Name);

				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxOseStorageLocationGeneralTable.NAME, PmxOseStorageLocationGeneralTable.Columns.Name.NAME, LocationDataSet.Columns.DESCRIPTION.Name);

				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxOseGeneralTable.NAME, PmxOseGeneralTable.Columns.PmxWarehouseCode.NAME, LocationDataSet.Columns.WAREHOUSECODE.Name);

				strBuilder.Append(", ");
				strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxOseProductionLineTable.NAME));
				strBuilder.Append(".");
				strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxOseProductionLineTable.Columns.InputLocationCode.NAME));

				strBuilder.Append(", ");
				strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxOseProductionLineTable.NAME));
				strBuilder.Append(".");
				strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxOseProductionLineTable.Columns.OutputLocationCode.NAME));

				strBuilder.Append(", ");
				strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxOseProductionLineTable.NAME));
				strBuilder.Append(".");
				strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxOseProductionLineTable.Columns.RestLocationCode.NAME));

				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxOseWarehouseTable.NAME, PmxOseWarehouseTable.Columns.Name.NAME, LocationDataSet.Columns.WAREHOUSENAME.Name);


				strBuilder.Append(" FROM ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxOseStorageLocationGeneralTable.NAME));
				strBuilder.Append(" INNER JOIN ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxOseGeneralTable.NAME));
				strBuilder.Append(" ON ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseGeneralTable.NAME, PmxOseGeneralTable.Columns.Code.NAME);
				strBuilder.Append(" = ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseStorageLocationGeneralTable.NAME, PmxOseStorageLocationGeneralTable.Columns.Code.NAME);

				strBuilder.Append(" INNER JOIN ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxOseWarehouseTable.NAME));
				strBuilder.Append(" ON ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseGeneralTable.NAME, PmxOseGeneralTable.Columns.PmxWarehouseCode.NAME);
				strBuilder.Append(" = ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseWarehouseTable.NAME, PmxOseWarehouseTable.Columns.Code.NAME);

				strBuilder.Append("\r\n INNER JOIN ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxWarehouseTable.NAME));
				strBuilder.Append(" ON ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxWarehouseTable.NAME, PmxWarehouseTable.Columns.WarehouseCode.NAME);
				strBuilder.Append(" = ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseWarehouseTable.NAME, PmxOseWarehouseTable.Columns.SboWarehouseCode.NAME);

				strBuilder.Append("\r\n AND ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxWarehouseTable.NAME, PmxWarehouseTable.Columns.IsManagedByProdumex.NAME);
				strBuilder.Append(" = ");
				strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));



				strBuilder.Append(" INNER JOIN ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxOseProductionLineTable.NAME));
				strBuilder.Append(" ON ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseGeneralTable.NAME, PmxOseGeneralTable.Columns.Code.NAME);
				strBuilder.Append(" = ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseProductionLineTable.NAME, PmxOseProductionLineTable.Columns.Code.NAME);



				strBuilder.Append(" WHERE ");
				strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxOseStorageLocationGeneralTable.NAME));
				strBuilder.Append(".");
				strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxOseStorageLocationGeneralTable.Columns.IsActive.NAME));
				strBuilder.Append(" = ");
				strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));



				if (!String.IsNullOrEmpty(warehouseCode) || !String.IsNullOrEmpty(deviceID))
				{
					strBuilder.Append(" AND ( ");
					if (!String.IsNullOrEmpty(warehouseCode))
					{
						SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseGeneralTable.NAME, PmxOseGeneralTable.Columns.PmxWarehouseCode.NAME);
						strBuilder.Append(" = ");
						strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(warehouseCode, CultureInfo.InvariantCulture));
					}
					if (!String.IsNullOrEmpty(deviceID))
					{
						if (!String.IsNullOrEmpty(warehouseCode))
							strBuilder.Append(" OR ");

						strBuilder.AppendFormat("{0} IN ( SELECT {1} FROM {2} WHERE {3} = {4} )",
							SqlCommandHelper.EscapeTableColumnName(PmxOseGeneralTable.NAME, PmxOseGeneralTable.Columns.PmxWarehouseCode.NAME),
							SqlCommandHelper.EscapeTableColumnName(PmxThinClientWarehouseTable.NAME, PmxThinClientWarehouseTable.Columns.PmxWarehouseCode.NAME),
							SqlCommandHelper.EscapeTableName(PmxThinClientWarehouseTable.NAME),
							SqlCommandHelper.EscapeTableColumnName(PmxThinClientWarehouseTable.NAME, PmxThinClientWarehouseTable.Columns.ParentCode.NAME),
							SqlCommandHelper.FormatAndEscapeColumnValue(deviceID, CultureInfo.InvariantCulture));
					}
					strBuilder.Append(" )");
				}


				strBuilder.Append(" ORDER BY ");
				strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxOseStorageLocationGeneralTable.NAME));
				strBuilder.Append(".");
				strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxOseStorageLocationGeneralTable.Columns.Name.NAME));


				return strBuilder.ToString();
			}

			/// <summary>
			/// Gets the started production order for the Production line.
			/// </summary>
			/// <param name="productionLineCode">The production line code.</param>
			///  <param name="allowStartingProdOrderOnFlow">Allow starting prodution order on production receipt flow.</param>
			/// <returns></returns>
			public static string GetStartedProductionOrders(string productionLineCode, bool allowStartingProdOrderOnFlow)
			{
				StringBuilder strBuilder = new StringBuilder();
				strBuilder.Append("SELECT ");

				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxItemTable.NAME, PmxItemTable.Columns.CustomItemDescr.NAME, ProductionOrderDataSet.Columns.ITEMDESCRIPTION.Name);

				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.ItemCode.NAME, ProductionOrderDataSet.Columns.ITEMCODE.Name);

				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.DocEntry.NAME, ProductionOrderDataSet.Columns.PRODUCTION_ORDER_DOC_ENTRY.Name);

				strBuilder.Append(", CAST(");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.DocEntry.NAME);
				strBuilder.Append(" AS NVARCHAR) AS ");
				strBuilder.Append(SqlCommandHelper.EscapeColumnName(ProductionOrderDataSet.Columns.PRODUCTION_ORDER_DOC_ENTRY_AS_STRING.Name));

				strBuilder.Append(", CAST(");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.DocNum.NAME);
				strBuilder.Append(" AS NVARCHAR) AS ");
				strBuilder.Append(SqlCommandHelper.EscapeColumnName(ProductionOrderDataSet.Columns.PRODUCTION_ORDER_DOC_NUM_AS_STRING.Name));

				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.Comments.NAME, ProductionOrderDataSet.Columns.COMMENTS.Name);

				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.DocNum.NAME, ProductionOrderDataSet.Columns.DOC_NUM.Name);

				strBuilder.Append(", ");
				strBuilder.Append(SboRecordsetHelper.GetSelectPartsColumnAndIsColumnNull(PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.ProductionLineCode.NAME, ProductionOrderDataSet.Columns.PRODUCTION_LINE_CODE.Name));

				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.DueDate.NAME, ProductionOrderDataSet.Columns.DUE_DATE.Name);

				strBuilder.Append(", ");
				strBuilder.Append(SboRecordsetHelper.GetSelectPartsColumnAndIsColumnNull(PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.CardCode.NAME, ProductionOrderDataSet.Columns.CUSTOMER_CODE.Name));

				strBuilder.Append(", ");
				strBuilder.Append(SboRecordsetHelper.GetSelectPartsColumnAndIsColumnNull(SboBusinessPartnerTable.NAME, SboBusinessPartnerTable.Columns.CardName.NAME, ProductionOrderDataSet.Columns.CUSTOMER_DESCRIPTION.Name));

				strBuilder.Append(", ");
				strBuilder.Append(SboRecordsetHelper.GetSelectPartsColumnAndIsColumnNull(PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.ProductionOrderStepListKey.NAME, ProductionOrderDataSet.Columns.STEP_LIST_KEY.Name));

				strBuilder.Append(", (");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.PlannedQuantity.NAME);
				strBuilder.Append(" - ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.CompletedQuantity.NAME);
				strBuilder.Append(" - ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.RejectedQuantity.NAME);

				strBuilder.Append(" ) AS ");
				strBuilder.Append(SqlCommandHelper.EscapeColumnName(ProductionOrderDataSet.Columns.OPEN_QUANTITY.Name));


				strBuilder.Append(", ");
				strBuilder.Append(SboRecordsetHelper.GetSelectPartsColumnAndIsColumnNull(PmxItemTable.NAME, PmxItemTable.Columns.UOM.NAME, ProductionOrderDataSet.Columns.UOM.Name));

				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.Type.NAME, ProductionOrderDataSet.Columns.PRODUCTION_ORDER_TYPE.Name);
				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.ProductionStatus.NAME, ProductionOrderDataSet.Columns.PMX_PRODUCTION_STATUS.Name);


				strBuilder.Append(" FROM ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxProductionOrderTable.NAME));

				strBuilder.Append(" INNER JOIN ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTable.NAME));
				strBuilder.Append(" ON ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTable.NAME, PmxItemTable.Columns.ItemCode.NAME);
				strBuilder.Append(" = ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.ItemCode.NAME);

				strBuilder.Append(" LEFT JOIN ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(SboBusinessPartnerTable.NAME));
				strBuilder.Append(" ON ");
				SqlCommandHelper.AddTableColumnName(strBuilder, SboBusinessPartnerTable.NAME, SboBusinessPartnerTable.Columns.CardCode.NAME);
				strBuilder.Append(" = ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.CardCode.NAME);


				strBuilder.Append(" WHERE ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.ProductionLineCode.NAME);
				strBuilder.Append(" = ");
				strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(productionLineCode, CultureInfo.InvariantCulture));

				strBuilder.Append(" AND ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.Status.NAME);
				strBuilder.Append(" = ");
				strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboProductionOrderStatusColumnValues.Released.VALUE, CultureInfo.InvariantCulture));

				strBuilder.Append(" AND ");

				strBuilder.Append(" ( ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.ProductionStatus.NAME);
				strBuilder.Append(" = ");
				strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(PmxProductionStatusColumnValues.Started.VALUE, CultureInfo.InvariantCulture));

				if (allowStartingProdOrderOnFlow)
				{
					strBuilder.Append(" OR ");
					SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.ProductionStatus.NAME);
					strBuilder.Append(" = ");
					strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(PmxProductionStatusColumnValues.Planned.VALUE, CultureInfo.InvariantCulture));
				}

				strBuilder.Append(" ) ");

				strBuilder.Append(" ORDER BY ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.DueDate.NAME);


				return strBuilder.ToString();
			}

			/// <summary>
			/// Gets the production orders.
			/// </summary>
			/// <param name="productionLineCode">The production line code.</param>
			/// <param name="productionOrderDocEntry">The production order doc entry.</param>
			/// <param name="dbTool">The db tool.</param>
			/// <returns></returns>
			public static string GetProductionOrders(string productionLineCode, int? productionOrderDocEntry, DbTool dbTool)
			{
				DbQueryBuilder strBuilder = dbTool.GetQueryBuilder();

				strBuilder.Append("SELECT ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxItemTable.NAME, PmxItemTable.Columns.CustomItemDescr.NAME, ProductionOrderDataSet.Columns.ITEMDESCRIPTION.Name);

				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.ItemCode.NAME, ProductionOrderDataSet.Columns.ITEMCODE.Name);

				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.DocEntry.NAME, ProductionOrderDataSet.Columns.PRODUCTION_ORDER_DOC_ENTRY.Name);

				strBuilder.Append(", CAST(");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.DocEntry.NAME);
				strBuilder.Append(" AS NVARCHAR) AS ");
				strBuilder.Append(strBuilder.AsIdentifier(ProductionOrderDataSet.Columns.PRODUCTION_ORDER_DOC_ENTRY_AS_STRING.Name));

				strBuilder.Append(", CAST(");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.DocNum.NAME);
				strBuilder.Append(" AS NVARCHAR) AS ");
				strBuilder.Append(strBuilder.AsIdentifier(ProductionOrderDataSet.Columns.PRODUCTION_ORDER_DOC_NUM_AS_STRING.Name));

				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.Comments.NAME, ProductionOrderDataSet.Columns.COMMENTS.Name);

				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.DocNum.NAME, ProductionOrderDataSet.Columns.DOC_NUM.Name);

				strBuilder.Append(", ");
				strBuilder.Append(SboRecordsetHelper.GetSelectPartsColumnAndIsColumnNull(PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.ProductionLineCode.NAME, ProductionOrderDataSet.Columns.PRODUCTION_LINE_CODE.Name));

				strBuilder.Append(", ");
				strBuilder.Append(SboRecordsetHelper.GetSelectPartsColumnAndIsColumnNull(PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.ProductionOrderStepListKey.NAME, ProductionOrderDataSet.Columns.STEP_LIST_KEY.Name));

				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.DueDate.NAME, ProductionOrderDataSet.Columns.DUE_DATE.Name);

				strBuilder.Append(", ");
				strBuilder.Append(SboRecordsetHelper.GetSelectPartsColumnAndIsColumnNull(PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.CardCode.NAME, ProductionOrderDataSet.Columns.CUSTOMER_CODE.Name));

				strBuilder.Append(", ");
				strBuilder.Append(SboRecordsetHelper.GetSelectPartsColumnAndIsColumnNull(SboBusinessPartnerTable.NAME, SboBusinessPartnerTable.Columns.CardName.NAME, ProductionOrderDataSet.Columns.CUSTOMER_DESCRIPTION.Name));

				strBuilder.Append(", (");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.PlannedQuantity.NAME);
				strBuilder.Append(" - ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.CompletedQuantity.NAME);
				strBuilder.Append(" - ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.RejectedQuantity.NAME);

				strBuilder.Append(" ) AS ");
				strBuilder.Append(SqlCommandHelper.EscapeColumnName(ProductionOrderDataSet.Columns.OPEN_QUANTITY.Name));

				strBuilder.Append(", ");
				strBuilder.Append(SboRecordsetHelper.GetSelectPartsColumnAndIsColumnNull(PmxOseProductionLineTable.NAME, PmxOseProductionLineTable.Columns.InputLocationCode.NAME, ProductionOrderDataSet.Columns.INPUT_LOCATION_CODE.Name));

				strBuilder.Append(", ");
				strBuilder.Append(SboRecordsetHelper.GetSelectPartsColumnAndIsColumnNull(PmxItemTable.NAME, PmxItemTable.Columns.UOM.NAME, ProductionOrderDataSet.Columns.UOM.Name));

				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.Type.NAME, ProductionOrderDataSet.Columns.PRODUCTION_ORDER_TYPE.Name);
				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.ProductionStatus.NAME, ProductionOrderDataSet.Columns.PMX_PRODUCTION_STATUS.Name);
				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.BatchNumber.NAME, ProductionOrderDataSet.Columns.PMX_BATCH_NUM.Name);
				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.NrOfProdBatches.NAME, PmxProductionOrderTable.Columns.NrOfProdBatches.NAME);
				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.ProdBatchSize.NAME, PmxProductionOrderTable.Columns.ProdBatchSize.NAME);
				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.PlannedQuantity.NAME);
				strBuilder.AppendFormat(", " + strBuilder.IFNULL + "({0}, 1) AS {1}",
				SqlCommandHelper.EscapeTableColumnName(PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.CurrentProductionBatch.NAME),
				SqlCommandHelper.FormatAndEscapeColumnValue(PmxProductionOrderTable.Columns.CurrentProductionBatch.NAME, CultureInfo.InvariantCulture)
				);

				strBuilder.Append("\r\n FROM ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxProductionOrderTable.NAME));


				strBuilder.Append("\r\n INNER JOIN ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxWarehouseTable.NAME));
				strBuilder.Append(" ON ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxWarehouseTable.NAME, PmxWarehouseTable.Columns.WarehouseCode.NAME);
				strBuilder.Append(" = ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.Warehouse.NAME);

				strBuilder.Append("\r\n AND ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxWarehouseTable.NAME, PmxWarehouseTable.Columns.IsManagedByProdumex.NAME);
				strBuilder.Append(" = ");
				strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));



				strBuilder.Append("\r\n INNER JOIN ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTable.NAME));
				strBuilder.Append("\r\n ON ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTable.NAME, PmxItemTable.Columns.ItemCode.NAME);
				strBuilder.Append(" = ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.ItemCode.NAME);

				strBuilder.Append("\r\n LEFT JOIN ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(SboBusinessPartnerTable.NAME));
				strBuilder.Append(" ON ");
				SqlCommandHelper.AddTableColumnName(strBuilder, SboBusinessPartnerTable.NAME, SboBusinessPartnerTable.Columns.CardCode.NAME);
				strBuilder.Append(" = ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.CardCode.NAME);

				strBuilder.Append("\r\n LEFT JOIN ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxOseProductionLineTable.NAME));
				strBuilder.Append(" ON ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.ProductionLineCode.NAME);
				strBuilder.Append(" = ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxOseProductionLineTable.NAME, PmxOseProductionLineTable.Columns.Code.NAME);



				strBuilder.Append("\r\n WHERE ");
				strBuilder.Append(" ( ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.ProductionLineCode.NAME);
				strBuilder.Append(" IS NULL ");

				if (!string.IsNullOrEmpty(productionLineCode))
				{
					strBuilder.Append(" OR ");
					SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.ProductionLineCode.NAME);
					strBuilder.Append(" = ");
					strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(productionLineCode, CultureInfo.InvariantCulture));
				}
				strBuilder.Append(" ) ");

				strBuilder.Append("\r\n AND ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.Status.NAME);
				strBuilder.Append(" = ");
				strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboProductionOrderStatusColumnValues.Released.VALUE, CultureInfo.InvariantCulture));

				strBuilder.Append("\r\n AND ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.Type.NAME);
				strBuilder.Append(" = ");
				strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboProductionOrderTypeValues.Disassembly.VALUE, CultureInfo.InvariantCulture));


				if (productionOrderDocEntry.HasValue)
				{
					strBuilder.Append("\r\n AND ");
					SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.DocEntry.NAME);
					strBuilder.Append(" = ");
					strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(productionOrderDocEntry.Value, CultureInfo.InvariantCulture));

				}


				strBuilder.Append("\r\n ORDER BY ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.DueDate.NAME);


				return strBuilder.ToString();
			}

			/// <summary>
			/// Gets the items to receive.
			/// </summary>
			/// <param name="productionOrderDocEntry">The production order document entry.</param>
			/// <param name="onlyHasToBeLinedUp">if set to <c>true</c> [only has to be lined up].</param>
			/// <param name="useItemNameAsDescription">if set to <c>true</c> [use item name as description].</param>
			/// <param name="dbTool">The database tool.</param>
			/// <returns></returns>
			public static string GetItemsToReceive(List<int> productionOrderDocEntries, bool onlyHasToBeLinedUp, bool useItemNameAsDescription, DbTool dbTool)
			{
				//+wor1.IssuedQty, wor1.PlannedQty, wor1.U_PMX_QTYTOLPCT

				DbQueryBuilder strBuilder = dbTool.GetQueryBuilder();

				strBuilder.Append("SELECT DISTINCT ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, SboItemTable.NAME, SboItemTable.Columns.ItemCode.NAME, ProductionOrderLineDataSet.Columns.ITEMCODE.Name);

				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, SboItemTable.NAME, useItemNameAsDescription ? SboItemTable.Columns.ItemName.NAME : PmxItemTable.Columns.CustomItemDescr.NAME, ProductionOrderLineDataSet.Columns.ITEMDESCRIPTION.Name);

				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, SboItemTable.NAME, SboItemTable.Columns.CodeBars.NAME, ProductDataSet.Columns.GTIN.Name);

				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxProductionOrderLineTable.NAME, PmxProductionOrderLineTable.Columns.Optional.NAME, ProductionOrderLineDataSet.Columns.IS_OPTIONAL.Name);

				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxProductionOrderLineTable.NAME, PmxProductionOrderLineTable.Columns.LineNum.NAME, ProductionOrderLineDataSet.Columns.PRODUCTION_ORDER_LINE_NUM.Name);


				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxProductionOrderLineTable.NAME, PmxProductionOrderLineTable.Columns.DocEntry.NAME, ProductionOrderLineDataSet.Columns.PRODUCTION_ORDER_DOC_ENTRY.Name);

				//Only needed for screen
				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxProductionOrderLineTable.NAME, PmxProductionOrderLineTable.Columns.PlannedQuantity.NAME, ProductionOrderLineDataSet.Columns.QUANTITY.Name);

				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxProductionOrderLineTable.NAME, PmxProductionOrderLineTable.Columns.HasToBeLinedUp.NAME, ProductionOrderLineDataSet.Columns.HAS_TO_BE_LINED_UP.Name);

				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxItemTable.NAME, PmxItemTable.Columns.InventoryUom.NAME, ProductionOrderLineDataSet.Columns.UOM.Name);

				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxItemTable.NAME, PmxItemTable.Columns.UOM2.NAME, ProductionOrderLineDataSet.Columns.UOM2.Name);

				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxProductionOrderLineTable.NAME, PmxProductionOrderLineTable.Columns.IssuedQuantity.NAME, PmxProductionOrderLineTable.Columns.IssuedQuantity.NAME);

				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxProductionOrderLineTable.NAME, PmxProductionOrderLineTable.Columns.PlannedQuantity.NAME, PmxProductionOrderLineTable.Columns.PlannedQuantity.NAME);

				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxProductionOrderLineTable.NAME, PmxProductionOrderLineTable.Columns.QuantityTolerancePercentage.NAME, PmxProductionOrderLineTable.Columns.QuantityTolerancePercentage.NAME);

				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxProductionOrderLineTable.NAME, PmxProductionOrderLineTable.Columns.BaseQuantity.NAME, PmxProductionOrderLineTable.Columns.BaseQuantity.NAME);

				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.CompletedQuantity.NAME, PmxProductionOrderTable.Columns.CompletedQuantity.NAME);

				strBuilder.Append("\r\n FROM ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxProductionOrderLineTable.NAME));

				strBuilder.Append(" INNER JOIN ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTable.NAME));
				strBuilder.Append(" ON ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTable.NAME, PmxItemTable.Columns.ItemCode.NAME);
				strBuilder.Append(" = ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderLineTable.NAME, PmxProductionOrderLineTable.Columns.ItemCode.NAME);

				strBuilder.Append("\r\n INNER JOIN ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxProductionOrderTable.NAME));
				strBuilder.Append(" ON ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.DocEntry.NAME);
				strBuilder.Append(" = ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderLineTable.NAME, PmxProductionOrderLineTable.Columns.DocEntry.NAME);



				strBuilder.Append("\r\n WHERE ");

				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderLineTable.NAME, PmxProductionOrderLineTable.Columns.DocEntry.NAME);
				strBuilder.Append(" IN ");
				strBuilder.Append(" ( ");
				//strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(productionOrderDocEntry, CultureInfo.InvariantCulture));
				strBuilder.Append(strBuilder.AsOwnType(productionOrderDocEntries));
				strBuilder.Append(" ) ");

				strBuilder.Append("\r\n AND ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTable.NAME, PmxItemTable.Columns.InventoryItem.NAME);
				strBuilder.Append(" = ");
				strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));

				strBuilder.Append("\r\n AND ", strBuilder.IFNULL, "(");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTable.NAME, PmxItemTable.Columns.UseForTimeRegistration.NAME);
				strBuilder.AppendFormat(", {0} ) = {0} ",
				SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.N.VALUE, CultureInfo.InvariantCulture));

				if (onlyHasToBeLinedUp)
				{

					strBuilder.Append("\r\n AND ");
					SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderLineTable.NAME, PmxProductionOrderLineTable.Columns.HasToBeLinedUp.NAME);
					strBuilder.Append(" = ");
					strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));
				}


				strBuilder.Append("\r\n ORDER BY ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderLineTable.NAME, PmxProductionOrderLineTable.Columns.Optional.NAME);
				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderLineTable.NAME, PmxProductionOrderLineTable.Columns.LineNum.NAME);


				return strBuilder.ToString();
			}


			/// <summary>
			/// Gets the stock.
			/// </summary>
			/// <param name="productionLineCode">The productionline code.</param>
			/// <param name="itemCodeToReceive">The itemCodeToReceive code.</param>
			/// <param name="dbTool">The database tool.</param>
			/// <returns></returns>
			public static string GetStock(string productionLineCode, string itemCodeToReceive, DbTool dbTool)
			{
				/*
				 select PMX_ITRI.InternalKey, PMX_INVT.ItemCode, PMX_INVT.Quantity, PMX_ITRI.BatchNumber, PMX_ITRI.BestBeforeDate from PMX_INVT
				 inner join PMX_ITRI on PMX_ITRI.InternalKey = PMX_INVT.ItemTransactionalInfoKey
				 where PMX_INVT.ItemCode = 'ITEM05_DOTANI' and PMX_INVT.StorLocCode = 'DOTANI_PL'
				*/

				StringBuilder strBuilder = new StringBuilder();
				strBuilder.Append("SELECT ");

				SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.InternalKey.NAME);
				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.ItemCode.NAME);
				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.Quantity.NAME);
				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.BatchNumber1.NAME);
				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.BatchNumber2.NAME);
				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.BestBeforeDate.NAME);

				strBuilder.Append(" FROM ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxInventoryTotalTable.NAME));
				strBuilder.Append(" INNER JOIN ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalInfoTable.NAME));
				strBuilder.Append(" ON ");

				SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.ItemTransactionalInfoKey.NAME);
				strBuilder.Append(" = ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.InternalKey.NAME);

				strBuilder.Append(" WHERE ");
				strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxInventoryTotalTable.NAME));
				strBuilder.Append(".");
				strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxInventoryTotalTable.Columns.ItemCode.NAME));
				strBuilder.Append(" = ");
				strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(itemCodeToReceive, CultureInfo.InvariantCulture));
				strBuilder.Append(" AND ");
				strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxInventoryTotalTable.NAME));
				strBuilder.Append(".");
				strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxInventoryTotalTable.Columns.StorLocCode.NAME));
				strBuilder.Append(" = ");
				strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(productionLineCode, CultureInfo.InvariantCulture));

				return strBuilder.ToString();
			}


			/// <summary>
			/// Gets batch attributes.
			/// </summary>
			/// <param name="productionLineCode">The productionline code.</param>
			/// <param name="itemCodeToReceive">The itemCodeToReceive code.</param>
			/// <param name="dbTool">The database tool.</param>
			/// <returns></returns>
			public static string GetBatchAttributes(string itemCode, int? itriKey, DbTool dbTool)
			{
				/*
				  select "PMX_ITRI".ItemCode, "PMX_ITBA".BatchAttributeCode, "PMX_ITBA".ValueConvertor, "PMX_ITBA".AttributeValue, "PMX_ITBA".ItriKey, "PMX_ITBA".InternalKey
				  FROM "PMX_ITBA"
				  INNER JOIN "@PMX_BATT" ON "@PMX_BATT"."Code" = "PMX_ITBA"."BatchAttributeCode"
				  INNER JOIN "PMX_ITRI" ON "PMX_ITRI"."InternalKey" = "PMX_ITBA"."ItriKey"
				  WHERE "PMX_ITRI"."ItemCode" = N'ITEM02'
				*/

				StringBuilder strBuilder = new StringBuilder();
				strBuilder.Append("SELECT ");

				SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.ItemCode.NAME);
				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTransactionalBatchAttributeTable.NAME, PmxItemTransactionalBatchAttributeTable.Columns.BatchAttributeCode.NAME);
				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTransactionalBatchAttributeTable.NAME, PmxItemTransactionalBatchAttributeTable.Columns.ValueConvertor.NAME);
				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTransactionalBatchAttributeTable.NAME, PmxItemTransactionalBatchAttributeTable.Columns.AttributeValue.NAME);
				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTransactionalBatchAttributeTable.NAME, PmxItemTransactionalBatchAttributeTable.Columns.ItemTransactionalInfoKey.NAME);
				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTransactionalBatchAttributeTable.NAME, PmxItemTransactionalBatchAttributeTable.Columns.InternalKey.NAME);

				strBuilder.Append(" FROM ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalBatchAttributeTable.NAME));

				strBuilder.Append(" INNER JOIN ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxBatchAttributeTypeTable.NAME));
				strBuilder.Append(" ON ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxBatchAttributeTypeTable.NAME, PmxBatchAttributeTypeTable.Columns.Code.NAME);
				strBuilder.Append(" = ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTransactionalBatchAttributeTable.NAME, PmxItemTransactionalBatchAttributeTable.Columns.BatchAttributeCode.NAME);

				strBuilder.Append(" INNER JOIN ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalInfoTable.NAME));
				strBuilder.Append(" ON ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.InternalKey.NAME);
				strBuilder.Append(" = ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTransactionalBatchAttributeTable.NAME, PmxItemTransactionalBatchAttributeTable.Columns.ItemTransactionalInfoKey.NAME);

				strBuilder.Append(" WHERE ");
				strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalInfoTable.NAME));
				strBuilder.Append(".");
				strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalInfoTable.Columns.ItemCode.NAME));
				strBuilder.Append(" = ");
				strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(itemCode, CultureInfo.InvariantCulture));
				
				strBuilder.Append(" AND ");
				strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalInfoTable.NAME));
				strBuilder.Append(".");
				strBuilder.Append(SqlCommandHelper.EscapeColumnName(PmxItemTransactionalInfoTable.Columns.InternalKey.NAME));
				strBuilder.Append(" = ");
				strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(itriKey, CultureInfo.InvariantCulture));

				return strBuilder.ToString();
			}

			/// <summary>
			/// Gets the products on the line for disassembly.
			/// </summary>
			/// <param name="productionOrderDocEntry">The production order doc entry.</param>
			/// <param name="locationCode">The location code.</param>
			/// <param name="itemCode">The item code.</param>
			/// <param name="logisticCarrierLocationCode">The logistic carrier location code.</param>
			/// <returns></returns>
			public static string GetProductsOnLineDisassembly(int? productionOrderDocEntry, string locationCode, string itemCode, string logisticCarrierLocationCode, DbTool dbTool)
			{
				DbQueryBuilder strBuilder = dbTool.GetQueryBuilder();

				strBuilder.Append("SELECT ");
				strBuilder.Append(SboRecordsetHelper.GetSelectPartsColumnAndIsColumnNull(PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.BatchNumber1.NAME, ConsumeItemsForProductionDataSet.Columns.BATCHNUMBER.Name));

				strBuilder.Append(", ");
				strBuilder.Append(SboRecordsetHelper.GetSelectPartsColumnAndIsColumnNull(PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.BatchNumber2.NAME, ConsumeItemsForProductionDataSet.Columns.BATCHNUMBER2.Name));

				strBuilder.Append(", ");
				strBuilder.Append(SboRecordsetHelper.GetSelectPartsColumnAndIsColumnNull(PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.BestBeforeDate.NAME, ConsumeItemsForProductionDataSet.Columns.BESTBEFOREDATE.Name));

				strBuilder.Append(", ");
				strBuilder.Append(SboRecordsetHelper.GetSelectPartsColumnAndIsColumnNull(PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.ItemTransactionalInfoKey.NAME, ConsumeItemsForProductionDataSet.Columns.ITEMTRANSACTIONALINFOKEY.Name));

				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.ItemCode.NAME, ConsumeItemsForProductionDataSet.Columns.ITEMCODE.Name);

				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxItemTable.NAME, PmxItemTable.Columns.CustomItemDescr.NAME, ConsumeItemsForProductionDataSet.Columns.ITEMDESCRIPTION.Name);

				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxItemTable.NAME, PmxItemTable.Columns.IsLogisticCarrier.NAME, ConsumeItemsForProductionDataSet.Columns.ISLOGISTICCARRIER.Name);

				strBuilder.Append(", ");
				strBuilder.Append(SboRecordsetHelper.GetSelectPartsColumnAndIsColumnNull(PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.LogUnitIdentKey.NAME, ConsumeItemsForProductionDataSet.Columns.LUID.Name));

				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.QualityStatusCode.NAME, ConsumeItemsForProductionDataSet.Columns.QUALITYSTATUSCODE.Name);

				strBuilder.Append(", ", strBuilder.IFNULL, "( ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.Quantity.NAME);
				strBuilder.Append(", 0) AS ");
				strBuilder.Append(SqlCommandHelper.EscapeColumnName(ConsumeItemsForProductionDataSet.Columns.QUANTITY.Name));

				strBuilder.Append(", ", strBuilder.IFNULL, "( ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.QuantityUom2.NAME);
				strBuilder.Append(", 0) AS ");
				strBuilder.Append(SqlCommandHelper.EscapeColumnName(ConsumeItemsForProductionDataSet.Columns.QUANTITY_UOM2.Name));


				strBuilder.AppendFormat(", " + strBuilder.IFNULL + "({0}, {1}) AS {2} ",
				  SqlCommandHelper.EscapeTableColumnName(SboUomTable.NAME, SboUomTable.Columns.UomCode.NAME),
				  SqlCommandHelper.EscapeTableColumnName(SboItemTable.NAME, SboItemTable.Columns.InventoryUom.NAME),
				  SqlCommandHelper.EscapeColumnName(ConsumeItemsForProductionDataSet.Columns.UOM.Name));


				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxItemTable.NAME, PmxItemTable.Columns.UOM2.NAME, ConsumeItemsForProductionDataSet.Columns.UOM2.Name);


				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.StorLocCode.NAME, ConsumeItemsForProductionDataSet.Columns.LOCATIONCODE.Name);

				strBuilder.Append(", ");
				strBuilder.Append(SboRecordsetHelper.GetSelectPartsColumnAndIsColumnNull(PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.SSCC.NAME, ConsumeItemsForProductionDataSet.Columns.SSCC.Name));

				strBuilder.Append(", ");
				SqlCommandHelper.AddDoubleQuantityColumnWithName(strBuilder, ConsumeItemsForProductionDataSet.Columns.BASEQUANTITY.Name, 1);

				strBuilder.Append(", ");
				SqlCommandHelper.AddStringValueColumnWithName(strBuilder, ConsumeItemsForProductionDataSet.Columns.OPTIONAL.Name, SboBooleanColumnValues.N.VALUE);

				strBuilder.Append(", ");
				SqlCommandHelper.AddDoubleQuantityColumnWithName(strBuilder, ConsumeItemsForProductionDataSet.Columns.QTYTOLPERCENTAGE.Name, 0);

				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.InternalKey.NAME, ConsumeItemsForProductionDataSet.Columns.INTERNALKEY.Name);

				strBuilder.Append(", ");
				SqlCommandHelper.AddDoubleZeroColumnWithName(strBuilder, ConsumeItemsForProductionDataSet.Columns.QUANTITYREST.Name);

				strBuilder.Append(", ");
				SqlCommandHelper.AddDoubleZeroColumnWithName(strBuilder, ConsumeItemsForProductionDataSet.Columns.QUANTITYWASTE.Name);

				strBuilder.Append(", ");
				SqlCommandHelper.AddDoubleZeroColumnWithName(strBuilder, ConsumeItemsForProductionDataSet.Columns.QUANTITYUSED.Name);


				strBuilder.Append(", ");
				SqlCommandHelper.AddDoubleZeroColumnWithName(strBuilder, ConsumeItemsForProductionDataSet.Columns.QUANTITYREST_UOM2.Name);

				strBuilder.Append(", ");
				SqlCommandHelper.AddDoubleZeroColumnWithName(strBuilder, ConsumeItemsForProductionDataSet.Columns.QUANTITYWASTE_UOM2.Name);

				strBuilder.Append(", ");
				SqlCommandHelper.AddDoubleZeroColumnWithName(strBuilder, ConsumeItemsForProductionDataSet.Columns.QUANTITYUSED_UOM2.Name);


				strBuilder.Append("\r\nFROM ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxProductionOrderTable.NAME));

				strBuilder.Append("\r\nLEFT OUTER JOIN ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxInventoryTotalTable.NAME));
				strBuilder.Append(" ON ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.ItemCode.NAME);
				strBuilder.Append(" = ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.ItemCode.NAME);

				strBuilder.Append(" AND ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.StorLocCode.NAME);
				strBuilder.Append(" = ");
				strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(locationCode, CultureInfo.InvariantCulture));

				strBuilder.AppendFormat(" INNER JOIN {0}", SqlCommandHelper.EscapeTableName(PmxQualityStatusTable.NAME));
				strBuilder.AppendFormat(" ON {0}.{1} = {2}.{3}",
					SqlCommandHelper.EscapeTableName(PmxInventoryTotalTable.NAME),
					SqlCommandHelper.EscapeColumnName(PmxInventoryTotalTable.Columns.QualityStatusCode.NAME),
					SqlCommandHelper.EscapeTableName(PmxQualityStatusTable.NAME),
					SqlCommandHelper.EscapeColumnName(PmxQualityStatusTable.Columns.Code.NAME));
				strBuilder.AppendFormat(" AND {0}.{1} = {2}",
					SqlCommandHelper.EscapeTableName(PmxQualityStatusTable.NAME),
					SqlCommandHelper.EscapeColumnName(PmxQualityStatusTable.Columns.CanBeUsedForProduction.NAME),
					SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));

				strBuilder.Append("\r\nINNER JOIN ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTable.NAME));
				strBuilder.Append(" ON ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.ItemCode.NAME);
				strBuilder.Append(" = ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTable.NAME, PmxItemTable.Columns.ItemCode.NAME);


				strBuilder.Append("\r\n LEFT JOIN ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(SboUomTable.NAME));
				strBuilder.Append(" ON ");
				SqlCommandHelper.AddTableColumnName(strBuilder, SboUomTable.NAME, SboUomTable.Columns.UomEntry.NAME);
				strBuilder.Append(" = ");
				SqlCommandHelper.AddTableColumnName(strBuilder, SboItemTable.NAME, SboItemTable.Columns.InventoryUoMEntry.NAME);
				strBuilder.Append(" AND ");
				SqlCommandHelper.AddTableColumnName(strBuilder, SboUomTable.NAME, SboUomTable.Columns.UomEntry.NAME);
				strBuilder.Append(" <> -1 ");

				strBuilder.Append("\r\nLEFT JOIN ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalInfoTable.NAME));
				strBuilder.Append(" ON ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.ItemTransactionalInfoKey.NAME);
				strBuilder.Append(" = ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.InternalKey.NAME);


				strBuilder.Append("\r\nWHERE ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.DocEntry.NAME);
				strBuilder.Append(" = ");
				strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(productionOrderDocEntry, CultureInfo.InvariantCulture));

				if (!string.IsNullOrEmpty(logisticCarrierLocationCode))
				{
					strBuilder.Append(" AND ");
					SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTable.NAME, PmxItemTable.Columns.IsLogisticCarrier.NAME);
					strBuilder.Append(" = ");
					strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.N.VALUE, CultureInfo.InvariantCulture));

				}

				if (!string.IsNullOrEmpty(itemCode))
				{
					strBuilder.Append(" AND ");
					SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.ItemCode.NAME);
					strBuilder.Append(" = ");
					strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(itemCode, CultureInfo.InvariantCulture));

				}


				if (!string.IsNullOrEmpty(logisticCarrierLocationCode))
				{
					#region UNION
					strBuilder.Append("\r\nUNION ");

					strBuilder.Append(" SELECT ");

					strBuilder.Append(SboRecordsetHelper.GetSelectPartsColumnAndIsColumnNull(PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.BatchNumber1.NAME, ConsumeItemsForProductionDataSet.Columns.BATCHNUMBER.Name));

					strBuilder.Append(", ");
					strBuilder.Append(SboRecordsetHelper.GetSelectPartsColumnAndIsColumnNull(PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.BatchNumber2.NAME, ConsumeItemsForProductionDataSet.Columns.BATCHNUMBER2.Name));

					strBuilder.Append(", ");
					strBuilder.Append(SboRecordsetHelper.GetSelectPartsColumnAndIsColumnNull(PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.BestBeforeDate.NAME, ConsumeItemsForProductionDataSet.Columns.BESTBEFOREDATE.Name));

					strBuilder.Append(", ");
					strBuilder.Append(SboRecordsetHelper.GetSelectPartsColumnAndIsColumnNull(PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.ItemTransactionalInfoKey.NAME, ConsumeItemsForProductionDataSet.Columns.ITEMTRANSACTIONALINFOKEY.Name));

					strBuilder.Append(", ");
					SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.ItemCode.NAME, ConsumeItemsForProductionDataSet.Columns.ITEMCODE.Name);

					strBuilder.Append(", ");
					SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxItemTable.NAME, PmxItemTable.Columns.CustomItemDescr.NAME, ConsumeItemsForProductionDataSet.Columns.ITEMDESCRIPTION.Name);

					strBuilder.Append(", ");
					SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxItemTable.NAME, PmxItemTable.Columns.IsLogisticCarrier.NAME, ConsumeItemsForProductionDataSet.Columns.ISLOGISTICCARRIER.Name);

					strBuilder.Append(", ");
					strBuilder.Append(SboRecordsetHelper.GetSelectPartsColumnAndIsColumnNull(PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.LogUnitIdentKey.NAME, ConsumeItemsForProductionDataSet.Columns.LUID.Name));

					strBuilder.Append(", ");
					SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.QualityStatusCode.NAME, ConsumeItemsForProductionDataSet.Columns.QUALITYSTATUSCODE.Name);

					strBuilder.Append(", ");
					SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.Quantity.NAME, ConsumeItemsForProductionDataSet.Columns.QUANTITY.Name);

					strBuilder.Append(", ", strBuilder.IFNULL, "( ");
					SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.QuantityUom2.NAME);
					strBuilder.Append(", 0) AS ");
					strBuilder.Append(SqlCommandHelper.EscapeColumnName(ConsumeItemsForProductionDataSet.Columns.QUANTITY_UOM2.Name));


					strBuilder.AppendFormat(", " + strBuilder.IFNULL + "({0}, {1}) AS {2} ",
					  SqlCommandHelper.EscapeTableColumnName(SboUomTable.NAME, SboUomTable.Columns.UomCode.NAME),
					  SqlCommandHelper.EscapeTableColumnName(SboItemTable.NAME, SboItemTable.Columns.InventoryUom.NAME),
					  SqlCommandHelper.EscapeColumnName(ConsumeItemsForProductionDataSet.Columns.UOM.Name));


					strBuilder.Append(", ");
					SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxItemTable.NAME, PmxItemTable.Columns.UOM2.NAME, ConsumeItemsForProductionDataSet.Columns.UOM2.Name);


					strBuilder.Append(", ");
					SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.StorLocCode.NAME, ConsumeItemsForProductionDataSet.Columns.LOCATIONCODE.Name);

					strBuilder.Append(", ");
					strBuilder.Append(SboRecordsetHelper.GetSelectPartsColumnAndIsColumnNull(PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.SSCC.NAME, ConsumeItemsForProductionDataSet.Columns.SSCC.Name));

					strBuilder.Append(", ");
					SqlCommandHelper.AddDoubleQuantityColumnWithName(strBuilder, ConsumeItemsForProductionDataSet.Columns.BASEQUANTITY.Name, 1);

					strBuilder.Append(", ");
					SqlCommandHelper.AddStringValueColumnWithName(strBuilder, ConsumeItemsForProductionDataSet.Columns.OPTIONAL.Name, SboBooleanColumnValues.N.VALUE);

					strBuilder.Append(", ");
					SqlCommandHelper.AddDoubleQuantityColumnWithName(strBuilder, ConsumeItemsForProductionDataSet.Columns.QTYTOLPERCENTAGE.Name, 0);

					strBuilder.Append(", ");
					SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.InternalKey.NAME, ConsumeItemsForProductionDataSet.Columns.INTERNALKEY.Name);

					strBuilder.Append(", ");
					SqlCommandHelper.AddDoubleZeroColumnWithName(strBuilder, ConsumeItemsForProductionDataSet.Columns.QUANTITYREST.Name);

					strBuilder.Append(", ");
					SqlCommandHelper.AddDoubleZeroColumnWithName(strBuilder, ConsumeItemsForProductionDataSet.Columns.QUANTITYWASTE.Name);

					strBuilder.Append(", ");
					SqlCommandHelper.AddDoubleZeroColumnWithName(strBuilder, ConsumeItemsForProductionDataSet.Columns.QUANTITYUSED.Name);


					strBuilder.Append(", ");
					SqlCommandHelper.AddDoubleZeroColumnWithName(strBuilder, ConsumeItemsForProductionDataSet.Columns.QUANTITYREST_UOM2.Name);

					strBuilder.Append(", ");
					SqlCommandHelper.AddDoubleZeroColumnWithName(strBuilder, ConsumeItemsForProductionDataSet.Columns.QUANTITYWASTE_UOM2.Name);

					strBuilder.Append(", ");
					SqlCommandHelper.AddDoubleZeroColumnWithName(strBuilder, ConsumeItemsForProductionDataSet.Columns.QUANTITYUSED_UOM2.Name);

					strBuilder.Append("\r\nFROM ");
					strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxProductionOrderTable.NAME));

					strBuilder.Append("\r\nLEFT OUTER JOIN ");
					strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxInventoryTotalTable.NAME));
					strBuilder.Append(" ON ");
					SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.ItemCode.NAME);
					strBuilder.Append(" = ");
					SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.ItemCode.NAME);

					strBuilder.Append(" AND ");
					SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.StorLocCode.NAME);
					strBuilder.Append(" = ");
					strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(logisticCarrierLocationCode, CultureInfo.InvariantCulture));

					strBuilder.Append("\r\nINNER JOIN ");
					strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTable.NAME));
					strBuilder.Append(" ON ");
					SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.ItemCode.NAME);
					strBuilder.Append(" = ");
					SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTable.NAME, PmxItemTable.Columns.ItemCode.NAME);

					strBuilder.Append("\r\n LEFT JOIN ");
					strBuilder.Append(SqlCommandHelper.EscapeTableName(SboUomTable.NAME));
					strBuilder.Append(" ON ");
					SqlCommandHelper.AddTableColumnName(strBuilder, SboUomTable.NAME, SboUomTable.Columns.UomEntry.NAME);
					strBuilder.Append(" = ");
					SqlCommandHelper.AddTableColumnName(strBuilder, SboItemTable.NAME, SboItemTable.Columns.InventoryUoMEntry.NAME);
					strBuilder.Append(" AND ");
					SqlCommandHelper.AddTableColumnName(strBuilder, SboUomTable.NAME, SboUomTable.Columns.UomEntry.NAME);
					strBuilder.Append(" <> -1 ");

					strBuilder.Append("\r\nLEFT JOIN ");
					strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalInfoTable.NAME));
					strBuilder.Append(" ON ");
					SqlCommandHelper.AddTableColumnName(strBuilder, PmxInventoryTotalTable.NAME, PmxInventoryTotalTable.Columns.ItemTransactionalInfoKey.NAME);
					strBuilder.Append(" = ");
					SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.InternalKey.NAME);



					strBuilder.Append("\r\nWHERE ");
					SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.DocEntry.NAME);
					strBuilder.Append(" = ");
					strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(productionOrderDocEntry, CultureInfo.InvariantCulture));

					strBuilder.Append(" AND ");
					SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTable.NAME, PmxItemTable.Columns.IsLogisticCarrier.NAME);
					strBuilder.Append(" = ");
					strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.Y.VALUE, CultureInfo.InvariantCulture));

					if (!string.IsNullOrEmpty(itemCode))
					{
						strBuilder.Append(" AND ");
						SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.ItemCode.NAME);
						strBuilder.Append(" = ");
						strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(itemCode, CultureInfo.InvariantCulture));

					}

					#endregion
				}


				strBuilder.Append("\r\nORDER BY ");
				strBuilder.Append(SqlCommandHelper.EscapeColumnName(ConsumeItemsForProductionDataSet.Columns.OPTIONAL.Name));
				strBuilder.Append(" DESC, ");
				strBuilder.Append(SqlCommandHelper.EscapeColumnName(ConsumeItemsForProductionDataSet.Columns.ITEMCODE.Name));
				strBuilder.Append(", ");
				strBuilder.Append(SqlCommandHelper.EscapeTableColumnName(PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.InternalKey.NAME));

				return strBuilder.ToString();
			}

			/// <summary>
			/// Gets the tolerance.
			/// </summary>
			/// <param name="docEntry">The production order document entry.</param>
			/// <param name="dbTool">The database tool.</param>
			/// <returns></returns>
			public static string GetTolerance(int docEntry, DbTool dbTool)
			{
				//select wor1.U_PMX_QTYTOLPCT where docentry = 

				DbQueryBuilder strBuilder = dbTool.GetQueryBuilder();

				strBuilder.Append("SELECT ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxProductionOrderLineTable.NAME, PmxProductionOrderLineTable.Columns.QuantityTolerancePercentage.NAME, PmxProductionOrderLineTable.Columns.QuantityTolerancePercentage.NAME);

				strBuilder.Append("\r\n FROM ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxProductionOrderLineTable.NAME));

				strBuilder.Append("\r\n WHERE ");

				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderLineTable.NAME, PmxProductionOrderLineTable.Columns.DocEntry.NAME);
				strBuilder.Append(" = ");
				strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(docEntry, CultureInfo.InvariantCulture));

				return strBuilder.ToString();
			}

			/// <summary>
			/// Gets the minimum maximum for header consumption.
			/// </summary>
			/// <param name="productionOrderDocEntry">The production order document entry.</param>
			/// <param name="minQuantityColumnName">Minimum name of the quantity column.</param>
			/// <param name="maxQuantityColumnName">Maximum name of the quantity column.</param>
			/// <param name="dbTool">The db tool.</param>
			/// <returns></returns>
			public static string GetMinMaxForHeaderConsumption(int? productionOrderDocEntry, string minQuantityColumnName, string maxQuantityColumnName, DbTool dbTool)
			{
				/*select WOR1.LineNum, WOR1.ItemCode, RECEIPTS.Quantity, ISNULL(RECEIPTS.Quantity, 0) / WOR1.BaseQty AS headerQuantity
, (ISNULL(RECEIPTS.Quantity, 0) / WOR1.BaseQty) * 100.0 / (100.0 + WOR1.U_PMX_QTYTOLPCT) AS headerMinQuantity
, (ISNULL(RECEIPTS.Quantity, 0) / WOR1.BaseQty) * 100.0 / (100.0 - WOR1.U_PMX_QTYTOLPCT) AS headerMaxQuantity

from WOR1
inner join OWOR on OWOR.DocEntry = WOR1.DocEntry
left join
(
select IGN1.BaseEntry, IGN1.BaseLine, IGN1.BaseType, SUM(IGN1.Quantity) AS Quantity, oign.U_PMX_PRDR as productionRun
from IGN1
inner join OIGN on OIGN.DocEntry = ign1.DocEntry
GROUP BY IGN1.BaseEntry, IGN1.BaseLine, IGN1.BaseType, oign.U_PMX_PRDR
) RECEIPTS
on RECEIPTS.productionRun = ISNULL(owor.U_PMX_PRUN, 0)
AND RECEIPTS.BaseEntry = wor1.DocEntry
AND RECEIPTS.BaseLine = wor1.LineNum
AND RECEIPTS.BaseType = '202'

where wor1.DocEntry = 103
and U_PMX_OPTI = 'N'*/

				DbQueryBuilder strBuilder = dbTool.GetQueryBuilder();

				string tableNameForReceipts = "RECEIPTS";

				strBuilder.Append("SELECT ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxProductionOrderLineTable.NAME, PmxProductionOrderLineTable.Columns.LineNum.NAME, PmxProductionOrderLineTable.Columns.LineNum.NAME);

				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxProductionOrderLineTable.NAME, PmxProductionOrderLineTable.Columns.ItemCode.NAME, PmxProductionOrderLineTable.Columns.ItemCode.NAME);

				strBuilder.AppendFormat(", (" + strBuilder.IFNULL + "({0}, 0) / {1}) AS {2} ",
				SqlCommandHelper.EscapeTableColumnName(tableNameForReceipts, PmxProductionReceiptLineTable.Columns.Quantity.NAME),
				SqlCommandHelper.EscapeTableColumnName(PmxProductionOrderLineTable.NAME, PmxProductionOrderLineTable.Columns.BaseQuantity.NAME),
				SqlCommandHelper.EscapeColumnName(PmxProductionReceiptLineTable.Columns.Quantity.NAME)
				 );

				strBuilder.AppendFormat(", (" + strBuilder.IFNULL + "({0}, 0) / {1}) * 100.0 / (100.0 + {2}) AS {3} ",
				 SqlCommandHelper.EscapeTableColumnName(tableNameForReceipts, PmxProductionReceiptLineTable.Columns.Quantity.NAME),
				 SqlCommandHelper.EscapeTableColumnName(PmxProductionOrderLineTable.NAME, PmxProductionOrderLineTable.Columns.BaseQuantity.NAME),
				 SqlCommandHelper.EscapeTableColumnName(PmxProductionOrderLineTable.NAME, PmxProductionOrderLineTable.Columns.QuantityTolerancePercentage.NAME),
				 SqlCommandHelper.EscapeColumnName(minQuantityColumnName)
				  );

				strBuilder.AppendFormat(", (" + strBuilder.IFNULL + "({0}, 0) / {1}) * 100.0 / (100.0 - {2}) AS {3} ",
				 SqlCommandHelper.EscapeTableColumnName(tableNameForReceipts, PmxProductionReceiptLineTable.Columns.Quantity.NAME),
				 SqlCommandHelper.EscapeTableColumnName(PmxProductionOrderLineTable.NAME, PmxProductionOrderLineTable.Columns.BaseQuantity.NAME),
				 SqlCommandHelper.EscapeTableColumnName(PmxProductionOrderLineTable.NAME, PmxProductionOrderLineTable.Columns.QuantityTolerancePercentage.NAME),
				 SqlCommandHelper.EscapeColumnName(maxQuantityColumnName)
				  );



				strBuilder.Append("\r\nFROM ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxProductionOrderLineTable.NAME));

				strBuilder.Append("\r\n INNER JOIN ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxProductionOrderTable.NAME));
				strBuilder.Append(" ON ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.DocEntry.NAME);
				strBuilder.Append(" = ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderLineTable.NAME, PmxProductionOrderLineTable.Columns.DocEntry.NAME);


				strBuilder.Append("\r\n INNER JOIN ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTable.NAME));
				strBuilder.Append(" ON ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTable.NAME, PmxItemTable.Columns.ItemCode.NAME);
				strBuilder.Append(" = ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderLineTable.NAME, PmxProductionOrderLineTable.Columns.ItemCode.NAME);

				strBuilder.Append("\r\n LEFT JOIN (");
				{

					strBuilder.Append("\r\n \r\n  SELECT ");

					SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionReceiptLineTable.NAME, PmxProductionReceiptLineTable.Columns.BaseEntry.NAME);

					strBuilder.Append(", ");
					SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionReceiptLineTable.NAME, PmxProductionReceiptLineTable.Columns.BaseLine.NAME);

					strBuilder.Append(", ");
					SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionReceiptLineTable.NAME, PmxProductionReceiptLineTable.Columns.BaseType.NAME);

					strBuilder.AppendFormat(", SUM({0}) AS {1} ",
					 SqlCommandHelper.EscapeTableColumnName(PmxProductionReceiptLineTable.NAME, PmxProductionReceiptLineTable.Columns.Quantity.NAME),
					 SqlCommandHelper.EscapeColumnName(PmxProductionReceiptLineTable.Columns.Quantity.NAME)
					  );


					strBuilder.Append(", ");
					SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionReceiptTable.NAME, PmxProductionReceiptTable.Columns.ProductionRun.NAME);




					strBuilder.Append("\r\nFROM ");
					strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxProductionReceiptLineTable.NAME));

					strBuilder.Append("\r\n INNER JOIN ");
					strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxProductionReceiptTable.NAME));
					strBuilder.Append(" ON ");
					SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionReceiptTable.NAME, PmxProductionReceiptTable.Columns.DocEntry.NAME);
					strBuilder.Append(" = ");
					SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionReceiptLineTable.NAME, PmxProductionReceiptLineTable.Columns.DocEntry.NAME);

					strBuilder.Append("\r\n GROUP BY ");
					SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionReceiptLineTable.NAME, PmxProductionReceiptLineTable.Columns.BaseEntry.NAME);

					strBuilder.Append(", ");
					SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionReceiptLineTable.NAME, PmxProductionReceiptLineTable.Columns.BaseLine.NAME);

					strBuilder.Append(", ");
					SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionReceiptLineTable.NAME, PmxProductionReceiptLineTable.Columns.BaseType.NAME);

					strBuilder.Append(", ");
					SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionReceiptTable.NAME, PmxProductionReceiptTable.Columns.ProductionRun.NAME);






				}
				strBuilder.Append("\r\n ) AS ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(tableNameForReceipts));
				strBuilder.Append("\r\n ON ");
				SqlCommandHelper.AddTableColumnName(strBuilder, tableNameForReceipts, PmxProductionReceiptTable.Columns.ProductionRun.NAME);
				strBuilder.Append(" = ", strBuilder.IFNULL, "(");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderTable.NAME, PmxProductionOrderTable.Columns.ProductionRun.NAME);
				strBuilder.Append(", 0) ");

				strBuilder.Append("\r\n AND ");
				SqlCommandHelper.AddTableColumnName(strBuilder, tableNameForReceipts, PmxProductionReceiptLineTable.Columns.BaseEntry.NAME);
				strBuilder.Append(" = ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderLineTable.NAME, PmxProductionOrderLineTable.Columns.DocEntry.NAME);

				strBuilder.Append("\r\n AND ");
				SqlCommandHelper.AddTableColumnName(strBuilder, tableNameForReceipts, PmxProductionReceiptLineTable.Columns.BaseLine.NAME);
				strBuilder.Append(" = ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderLineTable.NAME, PmxProductionOrderLineTable.Columns.LineNum.NAME);



				strBuilder.Append("\r\n AND ");
				SqlCommandHelper.AddTableColumnName(strBuilder, tableNameForReceipts, PmxProductionReceiptLineTable.Columns.BaseType.NAME);
				strBuilder.Append(" = ");
				strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(SboObjectTypes.ProductionOrder, CultureInfo.InvariantCulture));

				strBuilder.Append("\r\n WHERE ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderLineTable.NAME, PmxProductionOrderLineTable.Columns.DocEntry.NAME);
				strBuilder.Append(" = ");
				strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(productionOrderDocEntry, CultureInfo.InvariantCulture));


				//Remove optional items
				strBuilder.Append("\r\n AND ", strBuilder.IFNULL, "(");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderLineTable.NAME, PmxProductionOrderLineTable.Columns.Optional.NAME);
				strBuilder.AppendFormat(" , {0} ) = {0} ",
					SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.N.VALUE, CultureInfo.InvariantCulture));

				strBuilder.Append("\r\n AND ", strBuilder.IFNULL, "(");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTable.NAME, PmxItemTable.Columns.UseForTimeRegistration.NAME);
				strBuilder.AppendFormat(" , {0} ) = {0} ",
					SqlCommandHelper.FormatAndEscapeColumnValue(SboBooleanColumnValues.N.VALUE, CultureInfo.InvariantCulture));


				strBuilder.Append("\r\n AND ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxProductionOrderLineTable.NAME, PmxProductionOrderLineTable.Columns.QuantityTolerancePercentage.NAME);
				strBuilder.Append(" < ");
				strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(100, CultureInfo.InvariantCulture));

				return strBuilder.ToString();
			}


			/// <summary>
			/// Gets the tolerance.
			/// </summary>
			/// <param name="docEntry">The production order document entry.</param>
			/// <param name="dbTool">The database tool.</param>
			/// <returns></returns>
			public static string GetLastBatch(int docEntry, DbTool dbTool)
			{
				/*
				 select top 1 obtn.DistNumber, pmx_itri.InternalKey, pmx_itri.InternalBatchNumber, pmx_itri.BestBeforeDate
				 from ign1
				 inner join oitl on oitl.ApplyEntry = ign1.DocEntry and oitl.ApplyLine = ign1.LineNum and oitl.applyType = 59
				 inner join itl1 on itl1.LogEntry = oitl.LogEntry
				 inner join obtn on obtn.ItemCode = itl1.ItemCode and obtn.AbsEntry = itl1.MdAbsEntry
				 inner join pmx_itri on pmx_itri.ItemCode = obtn.ItemCode and pmx_itri.BatchNumber = obtn.DistNumber
				 where ign1.BaseType = '202'
				 and ign1.baseEntry = 134
				 order by ign1.docentry desc, ign1.linenum desc, itl1.LogEntry desc
				 */

				DbQueryBuilder strBuilder = dbTool.GetQueryBuilder();

				strBuilder.Append("SELECT ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.BatchNumber1.NAME, PmxItemTransactionalInfoTable.Columns.BatchNumber1.NAME);
				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.InternalKey.NAME, PmxInventoryDetailTable.Columns.ItemTransactionalInfoKey.NAME);
				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.BatchNumber2.NAME, DefaultPmxDocumentLine.Columns.BatchNumber2.NAME);
				strBuilder.Append(", ");
				SqlCommandHelper.AddTableColumnNameWithAs(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.BestBeforeDate.NAME, PmxItemTransactionalInfoTable.Columns.BestBeforeDate.NAME);


				strBuilder.Append("\r\n FROM ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(SboProductionReceiptLineTable.NAME));

				strBuilder.Append("\r\n INNER JOIN ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(SboInventoryTransactionsLogTable.NAME));
				strBuilder.Append(" ON ");
				SqlCommandHelper.AddTableColumnName(strBuilder, SboInventoryTransactionsLogTable.NAME, SboInventoryTransactionsLogTable.Columns.ApplyEntry.NAME);
				strBuilder.Append(" = ");
				SqlCommandHelper.AddTableColumnName(strBuilder, SboProductionReceiptLineTable.NAME, SboProductionReceiptLineTable.Columns.DocEntry.NAME);
				strBuilder.Append(" AND ");
				SqlCommandHelper.AddTableColumnName(strBuilder, SboInventoryTransactionsLogTable.NAME, SboInventoryTransactionsLogTable.Columns.ApplyLine.NAME);
				strBuilder.Append(" = ");
				SqlCommandHelper.AddTableColumnName(strBuilder, SboProductionReceiptLineTable.NAME, SboProductionReceiptLineTable.Columns.LineNum.NAME);
				strBuilder.Append(" AND ");
				SqlCommandHelper.AddTableColumnName(strBuilder, SboInventoryTransactionsLogTable.NAME, SboInventoryTransactionsLogTable.Columns.ApplyType.NAME);
				strBuilder.Append(" = ");
				strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(59, CultureInfo.InvariantCulture));

				strBuilder.Append("\r\n INNER JOIN ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(SboInventoryTransactionsLogBatchesTable.NAME));
				strBuilder.Append(" ON ");
				SqlCommandHelper.AddTableColumnName(strBuilder, SboInventoryTransactionsLogBatchesTable.NAME, SboInventoryTransactionsLogBatchesTable.Columns.LogEntry.NAME);
				strBuilder.Append(" = ");
				SqlCommandHelper.AddTableColumnName(strBuilder, SboInventoryTransactionsLogTable.NAME, SboInventoryTransactionsLogTable.Columns.LogEntry.NAME);

				strBuilder.Append("\r\n INNER JOIN ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(SboBatchNumberMasterDataTable.NAME));
				strBuilder.Append(" ON ");
				SqlCommandHelper.AddTableColumnName(strBuilder, SboBatchNumberMasterDataTable.NAME, SboBatchNumberMasterDataTable.Columns.ItemCode.NAME);
				strBuilder.Append(" = ");
				SqlCommandHelper.AddTableColumnName(strBuilder, SboInventoryTransactionsLogBatchesTable.NAME, SboInventoryTransactionsLogBatchesTable.Columns.ItemCode.NAME);
				strBuilder.Append(" AND ");
				SqlCommandHelper.AddTableColumnName(strBuilder, SboBatchNumberMasterDataTable.NAME, SboBatchNumberMasterDataTable.Columns.AbsEntry.NAME);
				strBuilder.Append(" = ");
				SqlCommandHelper.AddTableColumnName(strBuilder, SboInventoryTransactionsLogBatchesTable.NAME, SboInventoryTransactionsLogBatchesTable.Columns.MdAbsEntry.NAME);

				strBuilder.Append("\r\n INNER JOIN ");
				strBuilder.Append(SqlCommandHelper.EscapeTableName(PmxItemTransactionalInfoTable.NAME));
				strBuilder.Append(" ON ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.ItemCode.NAME);
				strBuilder.Append(" = ");
				SqlCommandHelper.AddTableColumnName(strBuilder, SboBatchNumberMasterDataTable.NAME, SboBatchNumberMasterDataTable.Columns.ItemCode.NAME);
				strBuilder.Append(" AND ");
				SqlCommandHelper.AddTableColumnName(strBuilder, PmxItemTransactionalInfoTable.NAME, PmxItemTransactionalInfoTable.Columns.BatchNumber1.NAME);
				strBuilder.Append(" = ");
				SqlCommandHelper.AddTableColumnName(strBuilder, SboBatchNumberMasterDataTable.NAME, SboBatchNumberMasterDataTable.Columns.BatchNumber.NAME);


				strBuilder.Append("\r\n WHERE ");

				SqlCommandHelper.AddTableColumnName(strBuilder, SboProductionReceiptLineTable.NAME, SboProductionReceiptLineTable.Columns.BaseType.NAME);
				strBuilder.Append(" = ");
				strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(202, CultureInfo.InvariantCulture));

				strBuilder.Append(" AND ");
				SqlCommandHelper.AddTableColumnName(strBuilder, SboProductionReceiptLineTable.NAME, SboProductionReceiptLineTable.Columns.BaseEntry.NAME);
				strBuilder.Append(" = ");
				strBuilder.Append(SqlCommandHelper.FormatAndEscapeColumnValue(docEntry, CultureInfo.InvariantCulture));

				// order by ign1.docentry desc, ign1.linenum desc, itl1.LogEntry desc
				strBuilder.Append("\r\n ORDER BY ");
				SqlCommandHelper.AddTableColumnName(strBuilder, SboProductionReceiptLineTable.NAME, SboProductionReceiptLineTable.Columns.DocEntry.NAME);
				strBuilder.Append(" DESC, ");
				SqlCommandHelper.AddTableColumnName(strBuilder, SboProductionReceiptLineTable.NAME, SboProductionReceiptLineTable.Columns.LineNum.NAME);
				strBuilder.Append(" DESC, ");
				SqlCommandHelper.AddTableColumnName(strBuilder, SboInventoryTransactionsLogBatchesTable.NAME, SboInventoryTransactionsLogBatchesTable.Columns.LogEntry.NAME);
				strBuilder.Append(" DESC");

				return strBuilder.ToString();
			}


		}

		#endregion

		#region CLASSES

		/// <summary>
		/// 
		/// </summary>
		public class ItemSetpointInfo
		{
			private double m_lowerLimit;
			private double m_upperLimit;
			private double m_setPoint;

			/// <summary>
			/// Gets or sets the lower limit.
			/// </summary>
			/// <value>The lower limit.</value>
			public double LowerLimit
			{
				get
				{
					return m_lowerLimit;
				}
				set
				{
					m_lowerLimit = value;
				}
			}

			/// <summary>
			/// Gets or sets the setpoint.
			/// </summary>
			/// <value>The setpoint.</value>
			public double Setpoint
			{
				get
				{
					return m_setPoint;
				}
				set
				{
					m_setPoint = value;
				}
			}

			/// <summary>
			/// Gets or sets the upper limit.
			/// </summary>
			/// <value>The upper limit.</value>
			public double UpperLimit
			{
				get
				{
					return m_upperLimit;
				}
				set
				{
					m_upperLimit = value;
				}
			}

			/// <summary>
			/// Initializes a new instance of the <see cref="ItemSetpointInfo"/> class.
			/// </summary>
			/// <param name="lowerLimit">The lower limit.</param>
			/// <param name="setpoint">The setpoint.</param>
			/// <param name="upperLimit">The upper limit.</param>
			public ItemSetpointInfo(double lowerLimit, double setpoint, double upperLimit)
			{
				LowerLimit = lowerLimit;
				Setpoint = setpoint;
				UpperLimit = upperLimit;
			}

			/// <summary>
			/// Initializes a new instance of the <see cref="ItemSetpointInfo"/> class.
			/// </summary>
			/// <param name="setpoint">The setpoint.</param>
			public ItemSetpointInfo(double setpoint)
			{
				LowerLimit = setpoint;
				Setpoint = setpoint;
				UpperLimit = setpoint;
			}
		}

		#endregion
	}
}
